/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <signal.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

#define LOCK_FILE   "/tmp/xneur.pid"

FILE *stream;

// XConf Function
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Alphex Kaanoken <kaanoken@crew.org.ru>
 *
 *  NOTE: is a parser functions , initialize and parse
 *
 *  (c) Crew IT Research Labs 2004
 *
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "xconfig.h"

/*linked list operations*/
app_list *AddItem(app_list * ptr, char *name,int lpp)
{
  app_list *lp=ptr;
  int id=0;
  if (ptr!=NULL) {
    ++id;
    while (ptr->next != NULL) {
      ptr=ptr->next;
      ++id;
    }
    ptr->next=(app_list *) malloc(sizeof(app_list));
    ptr=ptr->next;
    ptr->next=NULL;
    ptr->id=id;
    ptr->name=strdup((const char *) name);
    ptr->lpp=lpp;
    return lp;
  }
  else {
    ptr=(app_list *) malloc(sizeof(app_list));
    ptr->next=NULL;
    ptr->id=id;
    ptr->name=strdup ((const char *) name);
    ptr->lpp=lpp;
    return ptr;
  }
}

app_list *DelItem(app_list * ptr, int id)
{
  app_list *prev=NULL;
  app_list *curr;
  curr=ptr;
  
  while(curr != NULL && curr->id != id) {
    prev=curr;
    curr=curr->next;
  }
  if (curr==NULL)
    return ptr;
  if (curr==ptr)
    ptr=curr->next;
  else
    prev->next=curr->next;
  free (curr->name);
  free (curr);
  return ptr;
}

app_list *FreeItems(app_list * ptr)
{
  if (ptr!=NULL) {
    while(ptr != NULL)
      ptr=DelItem (ptr, ptr->id);
  }
  return ptr;
}

/*copy file,read file and parse it functions*/
int xconf_copy_file(const char *src_path,const char *dst_path);
int xconf_copy_file(const char *src_path,const char *dst_path)
{
  char* buf = NULL;
  int buf_size;
  int dest_desc;
  int source_desc;
  struct stat sb;
  struct stat sb_t;
  char *cp;
  int *ip;
  int return_val=0;
  off_t n_read_total=0;
  int last_write_made_hole=0;
  int make_holes=0;
  mode_t mask;

  source_desc=open(src_path,O_RDONLY);
  if (source_desc<0){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot open source file: `%s'\n",src_path);
#endif
    return -1;
  }
  if(fstat(source_desc,&sb_t)){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot stat source file: `%s'\n",src_path);
#endif
    return -1;
  }
  mask=sb_t.st_mode;

  dest_desc=open(dst_path,O_WRONLY | O_TRUNC | O_CREAT,mask);
  if(dest_desc<0){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot create new file: `%s'\n",dst_path);
#endif
    return_val=-1;
    goto close_src_desc;
  }

  if (fstat (dest_desc, &sb)){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot read status of: `%s'\n",dst_path);
#endif
    return_val = -1;
    goto close_src_and_dst_desc;
  }

  buf_size=2048;
  buf=malloc(buf_size+sizeof(int));
  if(!buf){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot allocate %d bytes for buffer.\n",
	    buf_size+sizeof(int));
#endif
    return_val=-1;
    goto close_src_and_dst_desc;
  }

  for (;;){
    ssize_t n_read=read (source_desc, buf, buf_size);
    if (n_read < 0){
#ifdef DEBUG
      fprintf(stderr,"[ERR]: Error while reading source: `%s'\n",src_path);
#endif
      return_val=-1;
      goto close_src_and_dst_desc;
    }
    if (n_read == 0)
      break;/*the end (EOF)*/
    n_read_total += n_read;
    ip=0;
    if (make_holes){
      buf[n_read]=1;
      ip=(int *)buf;
      while(*ip++ ==0)/*reduce*/
	;
      /*Find first non-zero symbol*/
      cp=(char *) (ip - 1);
      while(*cp++ ==0)/*reduce*/
	;
      /* if we found its it rules,we can make a hole*/
      if(cp>buf + n_read){
	/*make hole-sucks with lseek*/
	if(lseek(dest_desc,(off_t)n_read,SEEK_CUR)<0L){
#ifdef DEBUG
	  fprintf(stderr,"[ERR]: Cannot seek in ...\n");
#endif
	  return_val=-1;
	  goto close_src_and_dst_desc;
	}
	last_write_made_hole=1;
      }
      else
	ip=0;
    }
    if(ip==0){
      size_t n = n_read;
      if(write(dest_desc,buf,n)!=n){
#ifdef DEBUG
	fprintf(stderr,"[ERR]: Cannot write to file: `%s'\n",dst_path);
#endif
	return_val=-1;
	goto close_src_and_dst_desc;
      }
      last_write_made_hole = 0;
    }
  }
  /*FIXME: ??? if we make a hole in last write, we need put to file
   * something at end*/
 close_src_and_dst_desc:
  free(buf);
  if (close(dest_desc)<0){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot close destination!\n");
#endif
    return_val=-1;
  }
 close_src_desc:
  if (close (source_desc) < 0){
#ifdef DEBUG
    fprintf(stderr,"[ERR]: Cannot close the source!\n");
#endif
    return_val = -1;
  }

  return return_val;
}

xconf *ParseLine(xconf * ptr,char *line);
xconf *ParseLine(xconf * ptr,char *line)
{
  if(!line)
    return ptr;

  int len=strlen((const char*)line)+1;
  char *f_word = (char *) malloc (len);
  char *word = (char *) malloc (len);

  int cp = 0;
  int j = -1;
  int i = 0;
  int action, key, modifier;

  if(len<=1){
    free(word);
    return ptr;
  }

  while (line[i] != ' ') {
		word[i] = line[i];
		++i;
	}
  word[i] = NULLSYM;	

  if(!strcmp(word,"DefaultMode"))
    cp=1;
  if(!strcmp(word,"ConvPoint"))
    cp=2;
  if(!strcmp(word,"AddApp"))
    cp=3;
  if(!strcmp(word,"AddBind"))
    cp=4;
  if(!strcmp(word,"ScanDelay"))
    cp=5;
  if(!strcmp(word,"VerboseLevel"))
    cp=6; 
  if(!strncmp(word,"#",1))
    cp=7;
  if(!strcmp (word, "LangDetectMode"))
	cp=8;
  if(!strcmp (word, "EngXkbGroup"))
	cp=9;
  if(!strcmp (word, "RusXkbGroup"))
	cp=10;
  if (!cp) {
    fprintf (stderr, "[WRN]: Unrecognized option '%s' in config file!\nIgnoring ...\n", word);
    free(word);
    return ptr;
  }
  
  /*going and getting to next word*/
  word = memset (word, NULLSYM, strlen (line) + 1);
  while (line[++i] != NULLSYM)
    word[++j] = line[i];
  word[++j] = NULLSYM;
  
  switch (cp) {
  case 1: // Get Default Mode (Manual/Auto)
    if ((ptr->DefaultMode = atoi (word)) > 1 || 
	(ptr->DefaultMode = atoi (word)) < 0) {
      fprintf (stderr,
	       "[WRN]: Bad value '%d' (use 0 or 1 for default mode), using default.\n",
	       atoi (word));
      ptr->DefaultMode = 0;
    }
    break;
  case 2: // Get Convertation Point
    if ((ptr->ConvPoint = atoi (word)) < 30 ||
	(ptr->ConvPoint = atoi (word)) > 300) {
      fprintf (stderr,
	       "[WRN]: Bad value '%d' (values must be in 30-300), using default.\n",
	       atoi (word));
      ptr->ConvPoint = 55;
    }
    break;
  case 3: // Get Applications Names
    if(!strlen(word)){
      fprintf(stderr,"[WRN]: None application WM_CLASS defined.\nIgnoring ...\n");
      free(word);
      return ptr;
    }
	int lpp = strlen(word);
	if(lpp >= 0 || lpp <= 100) {
      ptr->alist = AddItem (ptr->alist,word,lpp);
	}  
    else {
      fprintf(stderr,"[WRN]: Illegal value for application name or not defined.\nDon't use value.\n");		
    }
    break;
  case 4: // Get Keyboard Binds
	// Get Action  
	i=-1;  
    j=-1;
    f_word = memset (f_word, NULLSYM, strlen (line)+1);
	while (word[++i] != ' ')
      f_word[++j] = word[i]; 
    f_word[++j] = NULLSYM;	
	if(!strcmp(f_word,"None") || !strcmp(f_word,"0"))
      action=0;
    else if(!strcmp(f_word,"Undo") || !strcmp(f_word,"1"))
      action=1;
    else if(!strcmp(f_word,"ExLastStr") || !strcmp(f_word,"2"))
      action=2;
    else if(!strcmp(f_word,"ChgMode") || !strcmp(f_word,"3"))
      action=3;
	else if(!strcmp(f_word,"ChgSelected") || !strcmp(f_word,"4"))
      action=4;
    else{
      fprintf(stderr,"[WRN]: Invalid action name `%s'.\n",f_word);
      free(word);
      return ptr;
    }

    // Get key
    j=-1;
    f_word = memset (f_word, NULLSYM, strlen (line)+1);
    ++i;	
	while (word[i] != ' ') {
      f_word[++j] = word[i]; 
	  ++i;	
	}	
    f_word[++j] = NULLSYM;
	key = -1;
	if(!strcmp(f_word,"None") || !strcmp(f_word,"0"))
      key=0;
    if(!strcmp(f_word,"Break") || !strcmp(f_word,"Pause") || !strcmp(f_word,"1"))
      key=1;
    if(!strcmp(f_word,"ScrollLock") || !strcmp(f_word,"2"))
      key=2;
    if(!strcmp(f_word,"PrtSc") || !strcmp(f_word,"SysRq") || !strcmp(f_word,"3"))
      key=3;
    if (key < 0){
      fprintf(stderr,"[WRN]: Invalid key name `%s'.\n",f_word);
      free(word);
      return ptr;
    }

	// Get Modifier
    j=-1;
    f_word = memset (f_word, NULLSYM, strlen (line)+1);	
	++i;	
	while ((word[i] != NULLSYM)) {
      f_word[++j] = word[i]; 
	  ++i;	
	}
    f_word[++j] = NULLSYM;
	modifier = -1;
	if(!strcmp(f_word,"None") || !strcmp(f_word,"0"))
      modifier=0;
    if(!strcmp(f_word,"Shift") || !strcmp(f_word,"10"))
      modifier=10;
    if(!strcmp(f_word,"Ctrl") || !strcmp(f_word,"11"))
      modifier=11;
    if (modifier < 0){
      fprintf(stderr,"[WRN]: Invalid modifier name `%s'.\n",f_word);
      free(word);
      return ptr;
    }
	
	ptr->btable[action].key = key;
    ptr->btable[action].key_modifier = modifier;
    break;

  case 5: // Get Scaning Delay
    if( ((ptr->ScaningDelay = atoi (word)) < 1000 )
	|| (ptr->ScaningDelay > 30000 ) ){
      printf(
		 "ScaningDelay is set to not recommended value %d \n"	\
		 "(Recommended: 1000-30000). Set to default.\n",
		 ptr->ScaningDelay );
      ptr->ScaningDelay = DEFAULT_SCANNING_DELAY;
    }
    break;
  case 6: // Get Debug Mode
    if(!strcmp(word,"Silent"))
      ptr->VerboseMode=0;
    else if(!strcmp(word,"Debug"))
      ptr->VerboseMode=1;
    else if(!strcmp(word,"DevDebug"))
      ptr->VerboseMode=2;
    else {
      fprintf(stderr,"[WRN]: Illegal option for debug level `%s'.\n",word);
      free(word);
      return ptr;
    }
    break;
  case 7:
	break;	
  case 8:
	if ((ptr->LangDetectMode = atoi (word)) > 1
	    || (ptr->LangDetectMode = atoi (word)) < 0) {
	  fprintf (stderr,
	  "[WRN]: Bad value '%d' (use 0 or 1 for lang detection mode), using default.\n",
	  atoi (word));
	  ptr->LangDetectMode = 0;
	}
	break;	
  case 9:	  
	ptr->xkbGroup[0] = atoi (word);
	break;	
  case 10:
	ptr->xkbGroup[1] = atoi (word);
	break;	
  default:
    fprintf (stderr, "[WRN]: Ignored value '%s'.\n", word);
    break;
  }
  
  free (word);
  return ptr;
}

int xconf_create_file (xconf * ptr, const char *fl_name);
int xconf_create_file (xconf * ptr, const char *fl_name)
{
  FILE *stream = NULL;
  if ((stream = fopen (fl_name, "w")) != NULL) {
    fputs("# It's a default X Neural Switcher configuration file\n", stream);
    fputs("# all values are default\n\n", stream);
    fputs("# default mode in window, 0 is manual, 1 is automatically\n", stream);
    fputs("DefaultMode 0\n", stream);
    fputs("# it's a point for convertation words\n", stream);
    fputs("# recomendated value is 55, You can play with this value for\n", stream);
    fputs("# # custom rules.\n", stream);
    fputs("ConvPoint 55\n\n", stream);
    fputs("# Add Applications names for procces with xneur\n", stream);
    fputs("# Only for listed applications (it's window names)\n", stream);
    fputs("# xneur will process the input\n", stream);
    fputs("# Example:\n", stream);
    fputs("#AddApp Sylpheed\n\n", stream);
    fputs("AddApp Gedit\n", stream);
    fputs("AddApp Anjuta\n", stream);
    fputs("AddApp Sailo\n", stream);
    fputs("AddApp Gaim\n\n", stream);
	fputs("# define xkb group\n", stream);
	fputs("EngXkbGroup 0\n", stream);
	fputs("RusXkbGroup 1\n\n", stream);	  
	fputs("# Select algorithm of language detection\n", stream);
	fputs("# 0 - Algo by A. Kaanoken\n", stream);
	fputs("# 1 - Algo by A. Kuznetsov\n", stream);
	fputs("LangDetectMode 1\n", stream);	  
    fputs("# it's all\n", stream);

    fclose (stream);
	return SUCCESS;
  }
  return ERROR;
}

int xconf_load_file (xconf * ptr, const char *fl_name);
int xconf_load_file (xconf * ptr, const char *fl_name)
{
  FILE *stream = NULL;
  int sym = 0;
  int i = -1;
  /*States of Parser */
  char *t_word = (char *) malloc (258);
  
  if ((stream = fopen (fl_name, "r")) != NULL) {
    while ((sym = fgetc (stream)) != EOF) {
      switch (sym) {
        case '\n':
          if ((strlen ((const char *) t_word)) != 0) {
            t_word[++i] = NULLSYM;
            ptr=ParseLine(ptr,t_word);
            t_word=memset(t_word, NULLSYM, 258);
            i = -1;
          }
          break;
        default:
          t_word[++i] = (unsigned char) sym;
          break;
      }
      
      if (i > 255) {
	    fprintf (stderr,"[ERR]: Configuration file '%s' is bad!\nExit(1)\n", fl_name);
	    free (t_word);
	    fclose (stream);
	    exit (1);
      }
    }
    fclose (stream);
    free (t_word);
    
    return SUCCESS;
  }
  else {
    fprintf (stderr,
	     "[WRN]: Cannot read config file: %s, using default settings!\n", fl_name);
    // Cannot read, create file
    ptr->create_file(ptr, fl_name);
    free (t_word);
    return WARNING;
  }
}

int xconf_uninit (xconf * ptr);
int xconf_uninit (xconf * ptr)
{
  ptr->alist=FreeItems(ptr->alist);
  free (ptr);
  return SUCCESS;
}

char* xconf_load_dict_file (const char *fl_name);
char* xconf_load_dict_file (const char *fl_name)
{
	FILE *stream = NULL;
	int sym = 0;
	int i = 0;
	// States of Parser 
	int isRead = 1;
	int t = 0;
	char *t_word = (char *) malloc (258);
	char *word = (char *) malloc (1);
	// init russian dictionary
	if ((stream = fopen (fl_name, "r")) != NULL) {
		word[0]='\0';
		t_word[i] = '|';
		t_word[++i] = '\n';
		while ((sym = fgetc (stream)) != EOF) {
			switch (sym) {
				case '#':
					isRead = 0;
					break;
				case '\n':
					if ((t = strlen ((const char *) t_word)) != 0)
						isRead = 10;
					else
						isRead = 0;
					if (isRead) {
						t_word[i] = '|';
						t_word[++i] = NULLSYM;
						word = realloc(word, strlen((const char *)t_word) + strlen((const char *)word) + 1);
						strcat(word, t_word);
						//printf ("'%s'\n", word);
						t_word = memset (t_word, NULLSYM, 258);
						i = 0;
					}
					isRead = 1;
					break;
				default:
					if (isRead) {
						t_word[i] = (unsigned char) sym;
						t_word[++i] = NULLSYM;
						//printf ("'%s'\n", t_word);
					}
					break;
			}

			if (i > 255) {
				fprintf (stderr,
					 "[ERR]: Russian Dictionary file '%s' is bad!\nExit(1)\n", fl_name);
				free (t_word);
				fclose (stream);
				exit (1);
			}
		}
		fclose (stream);	
		free (t_word);		
		return word;
	}
	else {
		fprintf (stderr,
			 "[WRN]: Cannot read russian dictionary file: %s, russian dictionary not use!\n", fl_name);
		if (t_word != NULL) 
			free (t_word);
		return NULL;
	}
}

xconf *xconf_init (xconf * ptr)
{
  ptr = (xconf *) malloc (sizeof (struct _xconf));
  ptr->DefaultMode=AUTO_BY_KEYLOG;
  ptr->CurrentMode=AUTO_BY_KEYLOG;
  ptr->ConvPoint=55;	/*default values */
  ptr->LangDetectMode = 1;  /*new algorithm*/
  ptr->ScaningDelay=DEFAULT_SCANNING_DELAY;
  ptr->alist=NULL;
  ptr->aplist=NULL;
  ptr->VerboseMode=1; /*default normal debug*/
  ptr->xkbGroup[0]=0; /* default english keyboard group */
  ptr->xkbGroup[1]=1; /* default russian keyboard group */

  memcpy(ptr->btable, DEFAULT_BT, DEFAULT_BIND_TABLE_SIZE*sizeof(bind));
  
  // Function mapping
  ptr->copy_file = xconf_copy_file;
  ptr->create_file = xconf_create_file;
  ptr->load_file = xconf_load_file;
  ptr->uninit = xconf_uninit;
  ptr->load_dict_file = xconf_load_dict_file;
  return ptr;
}

void execute (char *cmd, gboolean sync)
{
	gboolean retval;

	if (sync != FALSE)
		retval = g_spawn_command_line_sync
			(cmd, NULL, NULL, NULL, NULL);
	else
		retval = g_spawn_command_line_async (cmd, NULL);

	if (retval == FALSE)
	{
		char *msg;

		msg = g_strdup_printf
			(_("Couldn't execute command: \"<span weight=\"bold\" color=\"red\">%s</span>\"\n"
			   "Verify that this command exists.\n"),cmd);
		printf("ERROR:%s",msg);
		g_free (msg);
	}
}

int get_xneur_pid()
{
  char *t_word = (char *) malloc (258);
  int sym = 0;
  int i = 0;
  int pid = 0;
  FILE* fpid = fopen(LOCK_FILE, "r");
  if (!fpid)
  {
	fprintf(stderr, "Failed to open lock file!\n");
	return 0;
  }
  while ((sym = fgetc (fpid)) != EOF) {
	t_word[i] = (unsigned char) sym;
	t_word[++i] = '\0';	  
  }
  fclose (fpid);
  pid = atoi(t_word);  
  free (t_word);
  return pid;	
}

void xneur_exit (GtkMenuItem *menuitem)
{
  if (get_xneur_pid > 0)
	  if (kill((pid_t)get_xneur_pid(), SIGTERM) == -1)
		printf("failed to send SIGTERM\n");
  gtk_main_quit();
  exit (1); 	  
}

void xneur_start_stop (GtkMenuItem *menuitem, STray *tray)
{
  if (get_xneur_pid > 0) {
	if (kill((pid_t)get_xneur_pid(), SIGTERM) == -1) {	  
	  execute ("xneur", FALSE);  
	  gtk_tooltips_set_tip (tray->tooltip,GTK_WIDGET (tray->eggtray),_("X Neural Switcher Daemon RUNNED"),NULL);
		return;
	}
	gtk_tooltips_set_tip (tray->tooltip,GTK_WIDGET (tray->eggtray),_("X Neural Switcher Daemon STOPPED"),NULL);
	return;
  }    
}
void xneur_about (GtkWidget *widget)
{ 
  wAbout = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (wAbout), _("\320\236 \320\277\321\200\320\276\320\263\321\200\320\260\320\274\320\274\320\265 \"X Neural Switcher\""));
  gtk_window_set_type_hint (GTK_WINDOW (wAbout), GDK_WINDOW_TYPE_HINT_DIALOG);
  vb1About = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vb1About);
  gtk_container_add (GTK_CONTAINER (wAbout), vb1About);
	
  l2About = gtk_label_new (_("\n<b>Gnome X Neural Switcher - GTK frontend for X Neural Switcher</b>\n\t\t\320\260\320\262\321\202\320\276\320\274\320\260\321\202\320\270\321\207\320\265\321\201\320\272\320\270\320\271 \320\277\320\265\321\200\320\265\320\272\320\273\321\216\321\207\320\260\321\202\320\265\320\273\321\214 \320\272\320\273\320\260\320\262\320\270\320\260\321\202\321\203\321\200\321\213 \320\264\320\273\321\217 Linux\t\t"));
  gtk_widget_show (l2About);
  gtk_box_pack_start (GTK_BOX (vb1About), l2About, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (l2About), TRUE);
  gtk_label_set_justify (GTK_LABEL (l2About), GTK_JUSTIFY_CENTER);

  i2About = gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (i2About);
  gtk_box_pack_start (GTK_BOX (vb1About), i2About, TRUE, TRUE, 0);
  gtk_widget_set_size_request (i2About, 20, 20);

  hb1About = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hb1About);
  gtk_box_pack_start (GTK_BOX (vb1About), hb1About, TRUE, TRUE, 0);

  gtk_widget_show (wAbout);
  
  btnOK = gtk_button_new ();
  g_signal_connect_swapped (G_OBJECT (btnOK), "clicked",
                              G_CALLBACK (gtk_widget_destroy),
                              G_OBJECT (wAbout));
  gtk_widget_show (btnOK);
  gtk_box_pack_end (GTK_BOX (hb1About), btnOK, FALSE, FALSE, 0);

  a1About = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (a1About);
  gtk_container_add (GTK_CONTAINER (btnOK), a1About);

  hb2About = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hb2About);
  gtk_container_add (GTK_CONTAINER (a1About), hb2About);

  i1About = gtk_image_new_from_stock ("gtk-close", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (i1About);
  gtk_box_pack_start (GTK_BOX (hb2About), i1About, FALSE, FALSE, 0);

  l1About = gtk_label_new_with_mnemonic (_("\320\227\320\260\320\272\321\200\321\213\321\202\321\214"));
  gtk_widget_show (l1About);
  gtk_box_pack_start (GTK_BOX (hb2About), l1About, FALSE, FALSE, 0);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (wAbout, wAbout, "wAbout");
  GLADE_HOOKUP_OBJECT (wAbout, vb1About, "vb1About");
  GLADE_HOOKUP_OBJECT (wAbout, l2About, "l2About");
  GLADE_HOOKUP_OBJECT (wAbout, i2About, "i2About");
  GLADE_HOOKUP_OBJECT (wAbout, hb1About, "hb1About");
  GLADE_HOOKUP_OBJECT (wAbout, btnOK, "btnOK");
  GLADE_HOOKUP_OBJECT (wAbout, a1About, "a1About");
  GLADE_HOOKUP_OBJECT (wAbout, hb2About, "hb2About");
  GLADE_HOOKUP_OBJECT (wAbout, i1About, "i1About");
  GLADE_HOOKUP_OBJECT (wAbout, l1About, "l1About");
	
}

gboolean save_app (GtkTreeModel *model,
                GtkTreePath  *path,
                GtkTreeIter  *iter,
                gpointer      user_data)
  {
    gchar *ptr;

    /* Note: here we use 'iter' and not '&iter', because we did not allocate
     *  the iter on the stack and are already getting the pointer to a tree iter */
    gtk_tree_model_get (GTK_TREE_MODEL(store), iter, 0, &ptr, -1);

	fputs("AddApp ", stream); 
	fputs(ptr, stream); 
	fputs("\n", stream);

    g_free(ptr);  /* the strings for us when retrieving them */

    return FALSE; /* do not stop walking the store, call us with next row */
  }

void xneur_save_preference (xconf *xnc)
{
	char *config_file;
	size_t cnfbnmlen;
	const char* home = getenv("HOME");

	char *ptr;
	int modifier;
	
 	cnfbnmlen = strlen (home) + strlen (CNF_DIR) + 2; // 2 slashes will be added
	config_file = malloc (cnfbnmlen + strlen (CNF_NAME) + 1);
	sprintf (config_file, "%s/%s/%s", home, CNF_DIR, CNF_NAME);
	
	if ((stream = fopen (config_file, "w")) != NULL) {
    	fputs("# default mode in window, 0 is automatically, 1 is manual\n", stream);	
		fputs("DefaultMode ", stream);
		ptr = g_strdup_printf("%d", gtk_combo_box_get_active (GTK_COMBO_BOX(cboxMode)));
		fputs(ptr, stream); 
		fputs("\n\n", stream);
		
		fputs("# it's a point for convertation words\n", stream);
	    fputs("# recomendated value is 55, You can play with this value for\n", stream);
	    fputs("# # custom rules.\n", stream);	
		fputs("ConvPoint 55\n\n", stream); 

		fputs("# Select algorithm of language detection\n", stream);
		fputs("# 0 - Algo by A. Kaanoken\n", stream);
		fputs("# 1 - Algo by A. Kuznetsov\n", stream);
		fputs("LangDetectMode 1\n\n", stream); 
		
	    fputs("# Add Applications names for procces with xneur\n", stream);
    	fputs("# Only for listed applications (it's window names)\n", stream);
    	fputs("# xneur will process the input\n", stream);
    	fputs("# Example:\n", stream);
    	fputs("#AddApp Sylpheed\n", stream);
		gtk_tree_model_foreach(GTK_TREE_MODEL(store), save_app, NULL);
		fputs("\n", stream);
		
		fputs("AddBind ", stream); 	
		modifier = gtk_combo_box_get_active (GTK_COMBO_BOX(combobox4));
		if (modifier > 0) {
			modifier += 9;
		}			
		ptr = g_strdup_printf("1 %d %d", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox3)), modifier);								
		fputs(ptr, stream); 
		fputs("\n", stream);
		
		fputs("AddBind ", stream); 
		modifier = gtk_combo_box_get_active (GTK_COMBO_BOX(combobox6));
		if (modifier > 0) {
			modifier += 9;
		}			
		ptr = g_strdup_printf("2 %d %d", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox5)), modifier);								
		fputs(ptr, stream); 
		fputs("\n", stream);
		
		fputs("AddBind ", stream); 
		modifier = gtk_combo_box_get_active (GTK_COMBO_BOX(combobox8));
		if (modifier > 0) {
			modifier += 9;
		}			
		ptr = g_strdup_printf("3 %d %d", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox7)), modifier);								
		fputs(ptr, stream); 
		fputs("\n", stream);
		
		fputs("AddBind ", stream); 
		modifier = gtk_combo_box_get_active (GTK_COMBO_BOX(combobox10));
		if (modifier > 0) {
			modifier += 9;
		}			
		ptr = g_strdup_printf("4 %d %d", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox9)), modifier);								
		fputs(ptr, stream); 
		fputs("\n\n", stream);
		
		fputs("# define xkb group\n", stream);
		fputs("EngXkbGroup ", stream);
		ptr = g_strdup_printf("%d\n", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox11)));
		fputs(ptr, stream);
		fputs("RusXkbGroup ", stream);
		ptr = g_strdup_printf("%d\n\n", gtk_combo_box_get_active (GTK_COMBO_BOX(combobox12)));
		fputs(ptr, stream);	
		
		fclose (stream);
	}	
	// restart application with new settings
    if (get_xneur_pid > 0)
	  if (kill((pid_t)get_xneur_pid(), SIGTERM) == -1)
		printf("failed to send SIGTERM\n");
	execute("xneur", FALSE);
	gtk_widget_destroy(wPreference);
}

void xneur_add_application ()
{
	GtkTreeIter   iter;
	FILE* fp = popen("xprop WM_CLASS", "r");
	char buffer[NAME_MAX];
	const char* cap = "WM_CLASS(STRING)";
	
	if (fp == NULL)
		return;
	if (fgets(buffer, NAME_MAX, fp) == NULL)
		return;
	if (fclose(fp))
		return;
	if (strncmp(buffer, cap, strlen(cap)) != 0)
		return;
	char* p = strstr(buffer, "\", \"");
	if (p == NULL)
		return;
	if (strlen(p += 4) < 2)
		return;
	p[strlen(p) - 2] = '\0';
	
	gtk_list_store_append(store, &iter);
  	gtk_list_store_set (store, &iter, 0, p, -1);
	
}

void xneur_rem_application ()
{
//	GtkTreePath *path;
	GtkTreeIter   iter;
	GtkTreeSelection *select;	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview1));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);
	if (gtk_tree_selection_get_selected (select, &store, &iter))        
	{		
		gtk_list_store_remove(GTK_LIST_STORE(store), &iter);
	}
}

void xneur_preference (GtkWidget *widget)
{
  const char* home = getenv("HOME");
  xconf *xnc = NULL;
  int cnf_len=strlen(home)+strlen(CNF_DIR)+strlen(CNF_NAME)+3;  
  char *config_file=(char *) malloc(cnf_len);
  int modifier;
  GtkTreeIter   iter;

  config_file = memset(config_file,'\0',cnf_len);  
  snprintf (config_file,cnf_len,"%s/%s/%s",getenv ("HOME"),CNF_DIR,CNF_NAME);	
  xnc = xconf_init(xnc);
  xnc->load_file(xnc,config_file);	
  free(config_file);
	 
  tooltips = gtk_tooltips_new ();

  wPreference = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (wPreference), _("\320\235\320\260\321\201\321\202\321\200\320\276\320\271\320\272\320\260 X Neural Switcher"));
  gtk_window_set_resizable (GTK_WINDOW (wPreference), FALSE);
	gtk_widget_show (wPreference);
	
  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (wPreference), vbox1);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 2);

  label1 = gtk_label_new (_("<b>\320\240\320\265\320\266\320\270\320\274 \321\200\320\260\320\261\320\276\321\202\321\213\t\t</b>"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);
  gtk_widget_set_size_request (label1, 165, -1);
  gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);

  cboxMode = gtk_combo_box_new_text ();
  gtk_widget_show (cboxMode);
  gtk_box_pack_start (GTK_BOX (hbox2), cboxMode, TRUE, TRUE, 0);
  gtk_widget_set_size_request (cboxMode, -1, 32);
  gtk_combo_box_append_text (GTK_COMBO_BOX (cboxMode), _("\320\220\320\262\321\202\320\276\320\274\320\260\321\202\320\270\321\207\320\265\321\201\320\272\320\270\320\271"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (cboxMode), _("\320\240\321\203\321\207\320\275\320\276\320\271"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (cboxMode), xnc->DefaultMode);
  
  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator1, -1, 7);

  label2 = gtk_label_new (_("<b>\320\241\320\277\320\270\321\201\320\276\320\272 \320\277\321\200\320\270\320\273\320\276\320\266\320\265\320\275\320\270\320\271</b>"));
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label2), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label2), 0.01, 0.5);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 3);

  scrllAppList = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrllAppList);
  gtk_box_pack_start (GTK_BOX (hbox3), scrllAppList, TRUE, TRUE, 0);
  gtk_widget_set_size_request (scrllAppList, 190, -1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrllAppList), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrllAppList), GTK_SHADOW_IN);

  treeview1 = gtk_tree_view_new ();  
  
  store = gtk_list_store_new (1, G_TYPE_STRING);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrllAppList), treeview1);
  gtk_tree_view_set_model (GTK_TREE_VIEW (treeview1), GTK_TREE_MODEL (store));
  gtk_widget_show (treeview1);  
  while (xnc->alist != NULL) {
  	gtk_list_store_append(store, &iter);
  	gtk_list_store_set (store, &iter, 0, xnc->alist->name, -1);
	xnc->alist = xnc->alist->next;
  }				  
  
  cell = gtk_cell_renderer_text_new ();					 
	
  column = gtk_tree_view_column_new_with_attributes (_("Приложение"), cell, "text", 0, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), GTK_TREE_VIEW_COLUMN (column));
  gtk_container_add (GTK_CONTAINER (scrllAppList), treeview1);
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview1), FALSE);  
  
  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox3), vbox2, TRUE, TRUE, 0);

  btnAddApp = gtk_button_new_with_mnemonic (_("\320\224\320\276\320\261\320\260\320\262\320\270\321\202\321\214..."));
  gtk_widget_show (btnAddApp);
  gtk_box_pack_start (GTK_BOX (vbox2), btnAddApp, FALSE, FALSE, 0);
  g_signal_connect_swapped (G_OBJECT (btnAddApp), "clicked",
                              G_CALLBACK (xneur_add_application),
                              G_OBJECT (wPreference));
  
  btnRemApp = gtk_button_new_with_mnemonic (_("\320\243\320\264\320\260\320\273\320\270\321\202\321\214"));
  gtk_widget_show (btnRemApp);
  gtk_box_pack_start (GTK_BOX (vbox2), btnRemApp, FALSE, FALSE, 0);
  g_signal_connect_swapped (G_OBJECT (btnRemApp), "clicked",
                              G_CALLBACK (xneur_rem_application),
                              G_OBJECT (wPreference));

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator2, -1, 7);

  label3 = gtk_label_new (_("<b>\320\241\320\276\321\207\320\265\321\202\320\260\320\275\320\270\321\217 \320\272\320\273\320\260\320\262\320\270\321\210</b>"));
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox1), label3, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label3), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label3), 0.01, 0.5);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, TRUE, TRUE, 0);

  label4 = gtk_label_new (_("\320\227\320\260\320\274\320\265\320\275\320\260/\320\236\321\202\320\274\320\265\320\275\320\260 \320\260\320\262\321\202\320\276\320\267\320\260\320\274\320\265\320\275\321\213  \t"));
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox4), label4, FALSE, FALSE, 0);

  combobox3 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox3);
  gtk_box_pack_start (GTK_BOX (hbox4), combobox3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox3, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox3), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox3), _("Pause/Break"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox3), _("Scroll Lock"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox3), _("Prt Sc/SysRq"));  
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox3), xnc->btable[1].key);

  combobox4 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox4);
  gtk_box_pack_start (GTK_BOX (hbox4), combobox4, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox4, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox4), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox4), _("Shift"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox4), _("Control"));
  modifier = 0;
  if (xnc->btable[1].key_modifier > 0)
	  modifier = xnc->btable[1].key_modifier - 9;
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox4), modifier);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox7, TRUE, TRUE, 0);

  label7 = gtk_label_new (_("\320\227\320\260\320\274\320\265\320\275\320\260 \320\277\320\276\321\201\320\273\320\265\320\264\320\275\320\265\320\271 \321\201\321\202\321\200\320\276\320\272\320\270  \t"));
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (hbox7), label7, FALSE, FALSE, 0);

  combobox5 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox5);
  gtk_box_pack_start (GTK_BOX (hbox7), combobox5, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox5, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox5), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox5), _("Pause/Break"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox5), _("Scroll Lock"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox5), _("Prt Sc/SysRq"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox5), xnc->btable[2].key);

  combobox6 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox6);
  gtk_box_pack_start (GTK_BOX (hbox7), combobox6, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox6, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox6), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox6), _("Shift"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox6), _("Control"));
  modifier = 0;
  if (xnc->btable[2].key_modifier > 0)
	  modifier = xnc->btable[2].key_modifier - 9;
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox6), modifier);  

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox8, TRUE, TRUE, 0);

  label8 = gtk_label_new (_("\320\241\320\274\320\265\320\275\320\260 \321\200\320\265\320\266\320\270\320\274\320\260 \321\200\320\260\320\261\320\276\321\202\321\213\t\t"));
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (hbox8), label8, FALSE, FALSE, 0);

  combobox7 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox7);
  gtk_box_pack_start (GTK_BOX (hbox8), combobox7, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox7, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox7), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox7), _("Pause/Break"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox7), _("Scroll Lock"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox7), _("Prt Sc/SysRq"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox7), xnc->btable[3].key);

  combobox8 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox8);
  gtk_box_pack_start (GTK_BOX (hbox8), combobox8, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox8, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox8), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox8), _("Shift"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox8), _("Control"));
  modifier = 0;
  if (xnc->btable[3].key_modifier > 0)
	  modifier = xnc->btable[3].key_modifier - 9;
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox8), modifier);  

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox9, TRUE, TRUE, 0);

  label9 = gtk_label_new (_("\320\227\320\260\320\274\320\265\320\275\320\260 \320\262\321\213\320\264\320\265\320\273\320\265\320\275\320\276\320\263\320\276 \321\202\320\265\320\272\321\201\321\202\320\260\t"));
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox9), label9, FALSE, FALSE, 0);

  combobox9 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox9);
  gtk_box_pack_start (GTK_BOX (hbox9), combobox9, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox9, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox9), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox9), _("Pause/Break"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox9), _("Scroll Lock"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox9), _("Prt Sc/SysRq"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox9), xnc->btable[4].key);

  combobox10 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox10);
  gtk_box_pack_start (GTK_BOX (hbox9), combobox10, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox10, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox10), _("None"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox10), _("Shift"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox10), _("Control"));
  modifier = 0;
  if (xnc->btable[4].key_modifier > 0)
	  modifier = xnc->btable[4].key_modifier - 9;
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox10), modifier);  

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator3, -1, 7);
  
  label10 = gtk_label_new (_("<b>Нумерация Раскладок</b>"));
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox1), label10, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label10), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label10), 0.01, 0.5);
  
  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox10, TRUE, TRUE, 0);

  label11 = gtk_label_new (_("Номер Английской Раскладки (в России обычно 0)\t"));
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (hbox10), label11, FALSE, FALSE, 0);
  
  combobox11 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox11);
  gtk_box_pack_start (GTK_BOX (hbox10), combobox11, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox11, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox11), _("0"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox11), _("1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox11), _("2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox11), _("3"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox11), xnc->xkbGroup[0]);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox11, TRUE, TRUE, 0);

  label12 = gtk_label_new (_("Номер Русской (Win) Раскладки (в России обычно 1)\t"));
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox11), label12, FALSE, FALSE, 0);
  
  combobox12 = gtk_combo_box_new_text ();
  gtk_widget_show (combobox12);
  gtk_box_pack_start (GTK_BOX (hbox11), combobox12, TRUE, TRUE, 0);
  gtk_widget_set_size_request (combobox12, 70, -1);
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox12), _("0"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox12), _("1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox12), _("2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (combobox12), _("3"));
  gtk_combo_box_set_active (GTK_COMBO_BOX (combobox12), xnc->xkbGroup[1]);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator4, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator4, -1, 7);  
  
  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 2);
							  
  btnClosePref = gtk_button_new_from_stock ("gtk-close");
  gtk_widget_show (btnClosePref);
  gtk_box_pack_start (GTK_BOX (hbox1), btnClosePref, FALSE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, btnClosePref, _("\320\235\320\265 \321\201\320\276\321\205\321\200\320\260\320\275\321\217\321\202\321\214 \320\270\320\267\320\274\320\265\320\275\320\265\320\275\320\270\321\217"), NULL);
  g_signal_connect_swapped (G_OBJECT (btnClosePref), "clicked",
                              G_CALLBACK (gtk_widget_destroy),
                              G_OBJECT (wPreference));
							  
  btnOKPref = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (btnOKPref);
  gtk_box_pack_start (GTK_BOX (hbox1), btnOKPref, FALSE, TRUE, 0);
  gtk_widget_set_size_request (btnOKPref, 87, -1);
  gtk_tooltips_set_tip (tooltips, btnOKPref, _("\320\237\321\200\320\270\320\274\320\265\320\275\320\270\321\202\321\214 \320\275\320\260\321\201\321\202\321\200\320\276\320\271\320\272\320\270"), NULL);
  g_signal_connect_swapped (G_OBJECT (btnOKPref), "clicked",
                              G_CALLBACK (xneur_save_preference),
                              G_OBJECT (wPreference));

  
  // Store pointers to all widgets, for use by lookup_widget(). 
  GLADE_HOOKUP_OBJECT_NO_REF (wPreference, wPreference, "wPreference");
  GLADE_HOOKUP_OBJECT (wPreference, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (wPreference, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (wPreference, label1, "label1");
  GLADE_HOOKUP_OBJECT (wPreference, cboxMode, "cboxMode");
  GLADE_HOOKUP_OBJECT (wPreference, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (wPreference, label2, "label2");
  GLADE_HOOKUP_OBJECT (wPreference, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (wPreference, scrllAppList, "scrllAppList");
  GLADE_HOOKUP_OBJECT (wPreference, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (wPreference, btnAddApp, "btnAddApp");
  GLADE_HOOKUP_OBJECT (wPreference, btnRemApp, "btnRemApp");
  GLADE_HOOKUP_OBJECT (wPreference, hseparator2, "hseparator2");
  GLADE_HOOKUP_OBJECT (wPreference, label3, "label3");
  GLADE_HOOKUP_OBJECT (wPreference, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (wPreference, label4, "label4");
  GLADE_HOOKUP_OBJECT (wPreference, combobox4, "combobox4");
  GLADE_HOOKUP_OBJECT (wPreference, combobox3, "combobox3");
  GLADE_HOOKUP_OBJECT (wPreference, hbox7, "hbox7");
  GLADE_HOOKUP_OBJECT (wPreference, label7, "label7");
  GLADE_HOOKUP_OBJECT (wPreference, combobox5, "combobox5");
  GLADE_HOOKUP_OBJECT (wPreference, combobox6, "combobox6");
  GLADE_HOOKUP_OBJECT (wPreference, hbox8, "hbox8");
  GLADE_HOOKUP_OBJECT (wPreference, label8, "label8");
  GLADE_HOOKUP_OBJECT (wPreference, combobox7, "combobox7");
  GLADE_HOOKUP_OBJECT (wPreference, combobox8, "combobox8");
  GLADE_HOOKUP_OBJECT (wPreference, hbox9, "hbox9");
  GLADE_HOOKUP_OBJECT (wPreference, label9, "label9");
  GLADE_HOOKUP_OBJECT (wPreference, combobox9, "combobox9");
  GLADE_HOOKUP_OBJECT (wPreference, combobox10, "combobox10");
  GLADE_HOOKUP_OBJECT (wPreference, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (wPreference, hseparator3, "hseparator3");
  GLADE_HOOKUP_OBJECT (wPreference, btnClosePref, "btnClosePref");
  GLADE_HOOKUP_OBJECT (wPreference, btnOKPref, "btnOKPref");
  GLADE_HOOKUP_OBJECT_NO_REF (wPreference, tooltips, "tooltips");
  
  xnc->uninit(xnc);	
}

/*void xneur_change_mode (GtkMenuItem *menuitem,STray *tray)
{
	printf("[DBG]: Language before switch mode - %s\n", xnc->CurrentMode);
	switch (xnc->CurrentMode) {
		case AUTO_BY_KEYLOG:
			xnc->CurrentMode = MANUAL_ON_SHORTCUT;
			break;
		case MANUAL_ON_SHORTCUT:
			xnc->CurrentMode = AUTO_BY_KEYLOG;
			break;
		default:
			break;		
	}		
	printf("[DBG]: Language after switch mode - %s\n", xnc->CurrentMode);
}*/
