 /* Sven multimedia keyboard deamon
 * trayicon.c 
 *
 * Copyright (C) 2005 Eugene Morenko(More)
 * mailto: more@irpin.com
 * web: http://sven.linux.kiev.ua/
 * icq:325697438
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <X11/X.h>
#include <X11/Xlib.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtkplug.h>
#include <gdk/gdkx.h>

#include "interface.h"
#include "support.h"
#include "eggtrayicon.h"
#include "trayicon.h"
#include "pixmap.h"


static gboolean tray_icon_release (GtkWidget *widget, GdkEventButton *event, STray *tray)
{	
	if (event->button ==3)
	{
		gtk_menu_popdown (GTK_MENU (tray->popup_menu));
		return FALSE;
	}

	return TRUE;
}

gboolean tray_icon_press (GtkWidget *widget, GdkEventButton *event, STray *tray)
{

	if (event->button == 1) 
	{
		return 1;
	}  
	if (event->button == 2) 
	{
		return 1;
	}  	

	gtk_menu_popup (GTK_MENU (tray->popup_menu), NULL, NULL, NULL,
				NULL, event->button, event->time);

	return 0;
}


GtkWidget* create_menu_icon (STray *tray)
{
	GtkWidget *menu;
	GtkWidget *menuitem;
	GtkWidget *image;
	menu = gtk_menu_new ();
	
	menuitem = gtk_image_menu_item_new_with_mnemonic (_("Вкл./Выкл. Xneur"));
	image = gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU);
    gtk_widget_set_name (image, "image");
    gtk_widget_show (image);
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menuitem), image);
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	g_signal_connect(G_OBJECT(menuitem), "activate", G_CALLBACK(xneur_start_stop),tray);
	
	menuitem = gtk_image_menu_item_new_from_stock ("gtk-preferences", NULL);
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	g_signal_connect(G_OBJECT(menuitem), "activate", G_CALLBACK(xneur_preference),tray);
	
	menuitem = gtk_separator_menu_item_new ();
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	gtk_widget_set_sensitive (menuitem, FALSE);
	
	menuitem = gtk_image_menu_item_new_from_stock ("gtk-about", NULL);
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	g_signal_connect ((gpointer) menuitem, "activate",G_CALLBACK (xneur_about), tray);	

	/*menuitem = gtk_image_menu_item_new_from_stock ("Switch Mode", NULL);
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	g_signal_connect ((gpointer) menuitem, "activate",G_CALLBACK (xneur_change_mode),xnc);
	*/
	
	menuitem = gtk_image_menu_item_new_from_stock ("gtk-quit", NULL);
	gtk_widget_show (menuitem);
	gtk_container_add (GTK_CONTAINER (menu), menuitem);
	g_signal_connect ((gpointer) menuitem, "activate",G_CALLBACK (xneur_exit), tray);

 	return menu;
}


static gboolean tray_destroyed (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	init_tray_icon(user_data);
	printf("Destroy tray icon\n");
	return TRUE;
}


void init_tray_icon(gpointer data)
{
	STray *tray = (STray *)data;
	GtkWidget *evbox;
	
	tray = g_new0 (STray, 1);
	
	tray->tooltip = gtk_tooltips_new ();
	
	tray->popup_menu=create_menu_icon(tray);
	
	/* Event box */
	evbox = gtk_event_box_new ();
	gtk_event_box_set_visible_window(GTK_EVENT_BOX(evbox),0);
	gtk_widget_set_size_request (evbox, 25, 20);
		
	
	tray->eggtray = egg_tray_icon_new (_("X Neural Switcher Daemon"));
	
	
	gtk_tooltips_set_tip (tray->tooltip,GTK_WIDGET (tray->eggtray),_("X Neural Switcher Daemon RUNNED"),NULL);
			
	g_signal_connect (G_OBJECT (tray->eggtray), "button_press_event",G_CALLBACK (tray_icon_press),tray);
	g_signal_connect (G_OBJECT (tray->eggtray), "button_release_event",G_CALLBACK (tray_icon_release),tray);
	g_signal_connect (G_OBJECT (tray->eggtray), "destroy",G_CALLBACK (tray_destroyed), (gpointer) tray);
		
	tray->image = create_pixmap_type(20,24,24);
	gtk_container_add(GTK_CONTAINER(evbox),tray->image);
	gtk_container_add (GTK_CONTAINER (tray->eggtray), evbox);
	gtk_widget_show_all (GTK_WIDGET (tray->eggtray));
}
