/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Alphex Kaanoken <kaanoken@crew.org.ru>
 *  and after Andrew Crew Kuznetsov <andrew.crew.kuznetsov@gmail.com> 
 *  write additionally.
 
 *  (c) Crew IT Research Labs 2004
 *
 *  State: not good, poor code, need to reimplement (TODO:)
 *  -- Alphex Kaänoken <kaanoken@crew.org.ru>
 *  State: good new heuristic algo, poor code:
 *  -- Andrew Crew Kuznetsov <andrew.crew.kuznetsov@gmail.com> 
 *
 */

#include "detection.h"
#include "twolpoint.h"
#include "weight.h"

/*this function determine the symbol (a->1|b->0), ineternally used*/
/*NOTE: Autogenerated function*/
int isAB(char byte);
int isAB(char byte)
{
  switch(byte){
  case 'a':
  case 'e':
  case 'i':
  case 'o':
  case 'u':
  case 'y':
    return 1;
    break;
  case 'b':
  case 'c':
  case 'd':
  case 'f':
  case 'g':
  case 'h':
  case 'j':
  case 'k':
  case 'l':
  case 'm':
  case 'n':
  case 'p':
  case 'q':
  case 'r':
  case 's':
  case 't':
  case 'v':
  case 'w':
  case 'x':
  case 'z':
    return 0;
    break;
  default:
    return -1;
  }
}

/* this function determine this is Cyrillic word or not?
 * return percentage of this. (analysis of symbols)
 */
/*TODO: reimplement, some part really was generated automatically*/
int isCyrWord(const char *word)
{
  int i=0;
  int lw=0;int points=0;

  if(!word)
    return -1;
  if((lw=strlen(word))<=1)
    return 0; 
#if 0
  if(lw==2) /*simple 2 symbol word analysis*/{
    /*TODO: make a normal analysis with small words*/
    i=isAB(word[0])+isAB(word[1]);
    if(i==0)
      return -1;
    if(i<0)
      return 100;
  }
  i=-1;
  if(lw>=4) {
    while(i!=shr) {
      if(!isAB(word[i+1])&&!isAB(word[i+2])&&!isAB(word[i+3])&&!isAB(word[i+4]))
	points+=60;
      if(isAB(word[i+1])&&isAB(word[i+2])&&isAB(word[i+3])&&isAB(word[i+4]))
	points+=60;
      ++i;
    }
  }
  /*stage one - we see for 4a|b in word, with moving - ?*/
  /*it's not true, really we're look for the entire word's symbols - I can't 
    understand why i use here several loops?*/
  i=0;
  while(i!=lw-1){
    if(i!=0 || i!=lw-1)
      switch(word[i]){
      case '[':
      case ']':
      case '\'':
      case ',':
      case '.':
      case ';':
      case '>':
      case '<':
	points+=80;
	break;
      default:
	/*dummy*/
	break;
      }
    ++i;
  }
#endif
  /*stage two - we see for {}[];:'",.<> in word*/
  /*stage three lexical analysis
   * It's point was taken from output of my algorythm of searching for
   * slogs in english and russian. I'm use two dictionaryes
   */
  /*NOTE: this part generated automatically by my model, in future this model
   will be stored in CVS repositary and I add support for other languages 
   dynamically*/
  /*WTF?*/
  i=-1;
  while(i!=lw-1) {
    if(lw>=4 && i<=lw-4) { /*simple 4a&4b scanning*/
      if(!isAB(word[i+1])&&!isAB(word[i+2])&&!isAB(word[i+3])&&!isAB(word[i+4]))
	points+=60;
      if(isAB(word[i+1])&&isAB(word[i+2])&&isAB(word[i+3])&&isAB(word[i+4]))
	points+=60;
    }
    /*look for symbols inside the word*/
    if(i!=0 || i!=lw-1)
      switch(word[i]){
      case '[':
      case ']':
      case '\'':
      case ',':
      case '.':
      case ';':
      case '>':
      case '<':
	points+=80;
	break;
      default:
	/*dummy*/
	break;
      }
    
    /*2composes looking, generated automatically, just poor and simple code*/
    switch(word[i+1]) {
      /*check 2l B*/
    case 'b':
      switch(word[i+2]){
      case 'c':
	points+=BC;
	break;
      case 'd':
	points+=BD;
	break;
      case 'f':
	points+=BF;
	break;
      case 'g':
	points+=BG;
	break;
      case 'h':
	points+=BH;
	break;
      case 'j':
	points+=BJ;
	break;
      case 'k':
	points+=BK;
	break;
      case 'n':
	points+=BN;
	break;
      case 'p':
	points+=BP;
	break;
      case 'q':
	points+=BQ;
	break;
      case 't':
	points+=BT;
	break;
      case 'v':
	points+=BV;
	break;
      case 'w':
	points+=BW;
	break;
      }
      break;
      /*check 2l C*/
    case 'c':
      switch(word[i+2]){
      case 'b':
	points+=CB;
	break;
      case 'd':
	points+=CD;
	break;
      case 'f':
	points+=CF;
	break;
      case 'g':
	points+=CG;
	break;
      case 'j':
	points+=CJ;
	break;
      case 'm':
	points+=CM;
	break;
      case 'n':
	points+=CN;
	break;
      case 'v':
	points+=CV;
	break;
      case 'w':
	points+=CW;
	break;
      case 'x':
	points+=CX;
	break;
      case 'z':
	points+=CZ;
	break;
      }
      break;
      /*check 2l D*/
    case 'd':
      switch(word[i+2]){
      case 'b':
	points+=DB;
	break;
      case 'c':
	points+=DC;
	break;
      case 'f':
	points+=DF;
	break;
      case 'h':
	points+=DH;
	break;
      case 'j':
	points+=DJ;
	break;
      case 'k':
	points+=DK;
	break;
      case 'n':
	points+=DN;
	break;
      case 'p':
	points+=DP;
	break;
      case 's':
	points+=DS;
	break;
      case 't':
	points+=DT;
	break;
      case 'x':
	points+=DX;
	break;
      case 'z':
	points+=DZ;
	break;
      }
      break;
      /*check 2l E*/
    case 'e':
      switch(word[i+2]){
      case 'h':
	points+=EH;
	break;
      case 'k':
	points+=EK;
	break;
      }
      break;
      /*check 2l F*/
    case 'f':
      switch(word[i+2]){
      case 'b':
	points+=FB;
	break;
      case 'c':
	points+=FC;
	break;
      case 'd':
	points+=FD;
	break;
      case 'g':
	points+=FG;
	break;
      case 'h':
	points+=FH;
	break;
      case 'j':
	points+=FJ;
	break;
      case 'k':
	points+=FK;
	break;
      case 'n':
	points+=FN;
	break;
      case 'p':
	points+=FP;
	break;
      case 'q':
	points+=FQ;
	break;
      case 'v':
	points+=FV;
	break;
      case 'w':
	points+=FW;
	break;
      case 'x':
	points+=FX;
	break;
      case 'y':
	points+=FY;
	break;
      case 'z':
	points+=FZ;
	break;
      }
      break;
      /*check 2l G*/
    case 'g':
      switch(word[i+2]){
      case 'b':
	points+=GB;
	break;
      case 'j':
	points+=GJ;
	break;
      case 'k':
	points+=GK;
	break;
      case 't':
	points+=GT;
	break;
      case 'x':
	points+=GX;
	break;
      case 'z':
	points+=GZ;
	break;
      }
      break;
      /*check 2l H*/
    case 'h':
      switch(word[i+2]){
      case 'b':
	points+=HB;
	break;
      case 'c':
	points+=HC;
	break;
      case 'd':
	points+=HD;
	break;
      case 'f':
	points+=HF;
	break;
      case 'g':
	points+=HG;
	break;
      case 'j':
	points+=HJ;
	break;
      case 'k':
	points+=HK;
	break;
      case 'l':
	points+=HL;
	break;
      case 'm':
	points+=HM;
	break;
      case 'n':
	points+=HN;
	break;
      case 's':
	points+=HS;
	break;
      case 'v':
	points+=HV;
	break;
      case 'x':
	points+=HX;
	break;
      case 'z':
	points+=_HZ;
	break;
      }
      break;
      /*check 2l J*/
    case 'j':
      switch(word[i+2]){
      case 'b':
	points+=JB;
	break;
      case 'c':
	points+=JC;
	break;
      case 'd':
	points+=JD;
	break;
      case 'f':
	points+=JF;
	break;
      case 'g':
	points+=JG;
	break;
      case 'h':
	points+=JH;
	break;
      case 'i':
	points+=JI;
	break;
      case 'j':
	points+=JJ;
	break;
      case 'k':
	points+=JK;
	break;
      case 'l':
	points+=JL;
	break;
      case 'n':
	points+=JN;
	break;
      case 'p':
	points+=JP;
	break;
      case 'q':
	points+=JQ;
	break;
      case 'r':
	points+=JR;
	break;
      case 't':
	points+=JT;
	break;
      case 'v':
	points+=JV;
	break;
      case 'w':
	points+=JW;
	break;
      case 'x':
	points+=JX;
	break;
      case 'y':
	points+=JY;
	break;
      case 'z':
	points+=JZ;
	break;
      }
      break;
      /*check 2l K*/
    case 'k':
      switch(word[i+2]){
      case 'b':
	points+=KB;
	break;
      case 'f':
	points+=KF;
	break;
      case 'j':
	points+=KJ;
	break;
      case 'k':
	points+=KK;
	break;
      case 'm':
	points+=KM;
	break;
      case 't':
	points+=KT;
	break;
      case 'v':
	points+=KV;
	break;
      case 'x':
	points+=KX;
	break;
      case 'z':
	points+=KZ;
	break;
      }
      break;
    case 'l':
      switch(word[i+2]){
      case 'j':
	points+=LJ;
	break;
      case 'x':
	points+=LX;
	break;
      case 'z':
	points+=LZ;
	break;
      }
      break;
      /*check 2l M*/
    case 'm':
      switch(word[i+2]){
      case 'c':
	points+=MC;
	break;
      case 'd':
	points+=MD;
	break;
      case 'v':
	points+=MV;
	break;
      case 'x':
	points+=MX;
	break;
      case 'z':
	points+=MZ;
	break;
      }
      break;
      /*check 2l N*/
    case 'n':
      switch(word[i+2]){
      case 'j':
	points+=NJ;
	break;
      case 'm':
	points+=NM;
	break;
      case 'z':
	points+=NZ;
	break;
      }
      break;
      /*check 2l P*/
    case 'p':
      switch(word[i+2]){
      case 'b':
	points+=PB;
	break;
      case 'd':
	points+=PD;
	break;
      case 'f':
	points+=PF;
	break;
      case 'j':
	points+=PJ;
	break;
      case 'k':
	points+=PK;
	break;
      case 'v':
	points+=PV;
	break;
      case 'x':
	points+=PX;
	break;
      case 'z':
	points+=PZ;
	break;
      }
      break;
      /*check 2l Q*/
    case 'q':
      switch(word[i+2]){
      case 'a':
	points+=QA;
	break;
      case 'c':
	points+=QC;
	break;
      case 'd':
	points+=QD;
	break;
      case 'g':
	points+=QG;
	break;
      case 'i':
	points+=QI;
	break;
      case 'j':
	points+=QJ;
	break;
      case 'k':
	points+=QK;
	break;
      case 'l':
	points+=QL;
	break;
      case 'n':
	points+=QN;
	break;
      case 'o':
	points+=QO;
	break;
      case 'r':
	points+=QR;
	break;
      case 'v':
	points+=QV;
	break;
      case 'w':
	points+=QW;
	break;
      case 'x':
	points+=QX;
	break;
      case 'y':
	points+=QY;
	break;
      case 'z':
	points+=QZ;
	break;
      }
      break;
      /*check 2l R*/
    case 'r':
      switch(word[i+2]){
      case 'f':
	points+=RF;
	break;
      case 'h':
	points+=RH;
	break;
      case 'j':
	points+=RJ;
	break;
      }
      break;
      /*check 2l S*/
    case 's':
      switch(word[i+2]){
      case 'd':
	points+=SD;
	break;
      case 'q':
	points+=SQ;
	break;
      case 'x':
	points+=SX;
	break;
      case 'z':
	points+=SZ;
	break;
      }
      break;
    case 't':
      switch(word[i+2]){
      case 'c':
	points+=TC;
	break;
      case 'd':
	points+=TD;
	break;
      case 'g':
	points+=TG;
	break;
      case 'j':
	points+=TJ;
	break;
      case 'k':
	points+=TK;
	break;
      case 'n':
	points+=TN;
	break;
      case 'p':
	points+=TP;
	break;
      case 'q':
	points+=TQ;
	break;
      case 'v':
	points+=TV;
	break;
      case 'x':
	  points+=TX;
	  break;
      }
      break;
      /*check 2l U*/
    case 'u':
      switch(word[i+2]){
      case 'h':
	points+=UH;
	break;
      case 'j':
	points+=UJ;
	break;
      case 'k':
	points+=UK;
	break;
      }
      break;
      /*check 2l V*/
    case 'v':
      switch(word[i+2]){
      case 'b':
	points+=VB;
	break;
      case 'c':
	points+=VC;
	break;
      case 'd':
	points+=VD;
	break;
      case 'f':
	points+=VF;
	break;
      case 'g':
	points+=VG;
	break;
      case 'h':
	points+=VH;
	break;
      case 'j':
	points+=VJ;
	break;
      case 'k':
	points+=VK;
	break;
      case 'r':
	points+=VR;
	break;
      case 's':
	points+=VS;
	break;
      case 't':
	points+=VT;
	break;
      case 'z':
	points+=VZ;
	break;
      }
      break;
      /*check 2l W*/
    case 'w':
      switch(word[i+2]){
      case 'b':
	points+=WB;
	break;
      case 'j':
	points+=WJ;
	break;
      case 't':
	points+=WT;
	break;
      }
      break;
      /*check 2l X*/
    case 'x':
      switch(word[i+2]){
      case 'b':
	points+=XB;
	break;
      case 'f':
	points+=XF;
	break;
      case 'j':
	points+=XJ;
	break;
      case 'k':
	points+=XK;
	break;
      case 'm':
	points+=XM;
	break;
      case 'n':
	points+=XN;
	break;
      case 'r':
	points+=XR;
	break;
      case 't':
	points+=XT;
	break;
      case 'v':
	points+=XV;
	break;
      case 'y':
	points+=XY;
	break;
      }
      break;
	/*check 2l Y*/
    case 'y':
      switch(word[i+2]){
      case 'b':
	points+=YB;
	break;
      case 'f':
	points+=YF;
	break;
      case 'j':
	points+=YJ;
	break;
      case 't':
	points+=YT;
	break;
      case 'u':
	points+=YU;
	break;
      case 'y':
	points+=YY;
	break;
      case 'z':
	points+=YZ;
	break;
      }
      break;
      /*check 2l Z*/
    case 'z':
      switch(word[i+2]){
      case 'c':
	points+=ZC;
	break;
      case 'd':
	points+=ZD;
	break;
      case 'h':
	points+=ZH;
	break;
      case 'n':
	points+=ZN;
	break;
      case 'p':
	points+=ZP;
	break;
      case 'q':
	points+=ZQ;
	break;
      case 'r':
	points+=ZR;
	break;
      case 't':
	points+=ZT;
	break;
      case 'u':
	points+=ZU;
	break;
      case 'v':
	points+=ZV;
	break;
      case 'w':
	points+=ZW;
	break;
      case 'x':
	points+=ZX;
	break;
      case 'y':
	points+=ZY;
	break;
      }
      break;
    }

    ++i;
  }

  points=points/(lw/2+lw/4);
  return points;
}


/*this new function determine this is Cyrillic word or not?
 * return > 0 if eng, or < 0 if rus. (analysis of symbols)
 * Some part of this functions was generated automatically, 
 * and code looks not beatyfully, but it just works good and faster - it was 
 * was my target
 */
#define DICTIONARY "|[eq|qwe|qwt|qws|qwf|qwj|qre|qrt|qry|qrf|qrh|qrj|qrb|qty|qth|qtn|qt,|qt.|qye|qyt|qys|qyf|qyj|qyl|qyz|qyc|qyv|qyb|qy:|qy,|qy.|qie|qit|qif|qib|qpt|qpf|qae|qat|qaf|qaz|qa,|qa.|qde|qdf|qdj|qdb|qd,|qd.|qgw|qgf|qht|qhf|qhj|qjr|qjy|qju|qjh|qjl|qjn|qj[|qkt|qks|qkf|qkj|qkz|qkb|qkm|qle|qlt|qlf|qlj|qlz|qlv|qlb|ql,|qxt|qxf|qxb|qx.|qce|qcr|qct|qcf|qcj|qcz|qcc|qcb|qcn|qcm|qc,|qc.|qve|qvt|qvs|qvf|qvj|qvc|qvb|qv,|qb.|qne|qnt|qns|qnh|qnj|qnk|qnb|qn,|q[i|q[f|q[j|q[c|q,e|q,f|q,j|q..|wwe|wwt|wws|wwf|weq|wey|weu|wek|we:|wrt|wrf|wrj|wrb|wtq|wty|wtp|wtd|wtg|wtk|wtl|wtz|wtc|wtv|wtb|wtn|wt[|wt:|wyf|wpe|wsu|wsg|wdt|wfq|wfw|wft|wfy|wfg|wfh|wfk|wfz|wfv|wfn|wf[|wf:|wf,|wf.|wjq|wjr|wju|wjd|wjh|wjk|wjl|wjz|wjv|wj:|wj,|wj.|wkt|wlf|wck|wbq|wbt|wby|wbu|wbd|wbf|wbg|wbh|wbj|wbk|wbl|wbz|wbc|wbb|wbn|wb,|wb.|w,e|w.r|w..|eqr|eqy|eql|eqx|eqc|eqv|eqn|eq,|eq.|ewb|etq|etd|etv|et[|eyt|eyy|eyu|eyp|eyf|eyj|eyl|eyz|eyx|ey[|euy|euf|euh|euj|euk|eub|eiy|eij|eik|eix|eib|ei,|ei.|eoe|eoy|eoj|eob|eo.|epj|epc|epb|eaa|edh|edj|edk|edz|efq|efw|efp|efh|efk|efx|efn|egw|egt|egf|egh|egj|egk|egx|egv|egb|ehw|eht|ehu|ehp|ehs|ehd|ehf|ehg|ehh|ehj|ehk|ehl|ehz|ehx|ehc|ehv|ehb|ehn|ehm|eh:|eh;|ejp|ejh|ejk|ejc|ejn|ej,|ekr|ekt|ekf|ekj|ekz|ekc|ekm|ek:|elg|elh|elj|elz|ezo|ezp|ezd|ezk|ezc|ezv|exr|exf|exj|exb|exn|exm|ecf|ecg|ecj|ecz|ecx|ecv|ecb|ecn|ecm|ec[|ec,|evw|evr|evt|evd|evf|evh|evj|evk|evz|evx|evc|evv|evb|evm|ev:|ebw|ebp|ebh|ebk|ebn|enx|e[e|e[r|e[t|e[y|e[u|e[i|e[d|e[f|e[h|e[j|e[k|e[c|e[v|e[b|e[n|e[:|e[,|e[.|e:j|e;e|e;r|e;t|e;y|e;f|e;j|e;k|e;l|e;x|e;c|e;b|e;n|e;m|e;;|e;,|e;.|e,e|e,r|e,t|e,y|e,f|e,h|e,j|e,k|e,z|e,x|e,c|e,b|e,m|e,]|e,;|e,,|e,.|e.o|e.x|e.n|e.:|e.,|e..|rwt|rwb|rek|rex|re[|rrt|rrj|rrb|rtq|rtt|rtk|rtv|rye|ryf|ryj|ryz|ru<|rpf|rpj|rdt|rdf|rdj|rdb|rfq|rfw|rft|rfy|rfp|rfg|rfh|rfj|rfk|rfz|rfx|rfc|rfv|rfb|rfn|rf[|rf;|rht|rhs|rhf|rhj|rhz|rhb|rh;|rh.|rjq|rjr|rjt|rjy|rji|rjp|rjd|rjf|rjg|rjh|rjj|rjk|rjl|rjz|rjx|rjc|rjv|rjb|rjn|rj[|rj;|rj,|rj.|rkt|rkf|rkj|rkz|rk>|rlj|rxt|rcw|rct|rcd|rcf|rcg|rcj|rck|rcz|rcb|rcn|rc:|rc,|rc.|rvt|rvj|rv:|rbq|rbt|rbp|rbd|rbf|rbg|rbh|rbj|rbk|rbz|rbx|rbc|rbv|rbn|rb[|rb:|rnh|rnj|rnz|rnb|rmz|r[b|r;t|r.h|r.v|r.[|r..|tqw|tqr|tqt|tqy|tqi|tqp|tqa|tqg|tqh|tqk|tql|tqx|tqc|tqv|tqn|tq[|tq:|tq,|tq.|twr|twt|twy|tws|twf|twj|twc|twb|tw:|tw,|tw.|teh|tek|tez|te[|trw|trr|trt|trd|trf|trh|trj|trk|trl|trc|trb|trn|tr,|tr.|ttq|ttw|ttd|ttx|ttc|ttv|ttn|tt[|tt:|tt.|tyw|tyt|tyy|tys|tyd|tyf|tyh|tyj|tyz|tyx|tyc|tyb|tyn|ty[|tuy|tuh|tuj|tuk|tux|tuv|tu,|tiy|tij|tik|ti.|toh|toj|tpr|tpt|tpy|tpp|tps|tpd|tpf|tph|tpj|tpk|tpz|tpx|tpc|tpv|tpb|tpn|tpm|tp;|tp,|tp.|taa|taj|tdw|tde|tdt|tdy|tdu|tdi|tdp|tds|tdf|tdg|tdh|tdj|tdk|tdl|tdz|tdx|tdc|tdv|tdb|tdn|tdm|td[|td:|td,|td.|tfr|tfy|tfg|tfk|tfv|tfn|tf,|tgw|tge|tgt|tgy|tgi|tgs|tgf|tgg|tgh|tgj|tgk|tgz|tgx|tgc|tgb|tgn|tgm|tg,|tg.|thg|thj|thk|thz|thx|thv|thb|th[|tjw|tje|tjr|tjy|tju|tjo|tjp|tja|tjf|tjg|tjh|tjk|tjl|tjx|tjc|tjv|tjn|tj[|tj;|tj,|tke|tkr|tkt|tky|tks|tkd|tkf|tkj|tkk|tkz|tkx|tkc|tkb|tkn|tkm|tk:|tk>|tk,|tk.|tlr|tlt|tlp|tls|tld|tlf|tlg|tlh|tlj|tlk|tll|tlz|tlx|tlc|tlv|tlb|tlm|tl]|tl:|tl;|tl,|tl.|tzy|tzd|tzh|tzk|tzl|tzc|tzv|tzn|tz[|txe|txr|txy|txf|txj|txk|txb|txn|txm|tx,|tx.|tcw|tce|tct|tcy|tci|tcs|tcd|tcf|tcg|tcj|tck|tcz|tcx|tcc|tcv|tcb|tcn|tcm|tc[|tc]|tc:|tc<|tc,|tvw|tve|tvr|tvt|tvy|tvo|tvs|tvf|tvg|tvj|tvk|tvz|tvx|tvc|tvb|tvn|tvm|tv:|tv,|tv.|tby|tbp|tbd|tbk|tbx|tbc|tbv|tbn|tb[|tb,|tb.|tnw|tnr|tnt|tny|tns|tnd|tnf|tnh|tnj|tnk|tnl|tnz|tnx|tnc|tnb|tnn|tnm|tn[|tn:|tn,|tn.|t[e|t[t|t[y|t[p|t[d|t[f|t[h|t[j|t[k|t[c|t[v|t[b|t[,|t[.|t:e|t;e|t;r|t;t|t;y|t;p|t;f|t;j|t;k|t;l|t;b|t;m|t;;|t;.|t<e|t,w|t,e|t,r|t,t|t,y|t,s|t,f|t,h|t,j|t,k|t,z|t,c|t,b|t,n|t,,|t,.|t.o|t.c|t.n|t..|ywt|yws|ywf|ywj|ywk|ywb|yw,|yeq|yey|yeo|yef|yeh|yek|yez|yex|yec|yen|yrw|yry|yrf|yrh|yrj|yrb|yrn|yr.|ytq|ytw|ytr|ytt|yty|ytu|ytp|yta|ytd|ytf|ytg|ytj|ytk|ytl|ytz|ytx|ytc|ytv|ytb|ytn|yt[|yt:|yt;|yt,|yt.|yye|yyt|yyy|yys|yyf|yyj|yyz|yyc|yyb|yy,|yy.|yur|yut|yud|yuf|yuh|yuj|yun|yu,|yu.|yit|yik|yi.|yob|ypf|ypj|ypb|yaf|yaj|ysq|ysr|ysy|ysd|ysx|ysv|ysb|ys[|ys{|ydt|ydf|ydj|ydb|yfq|yfw|yfe|yfr|yft|yfy|yfi|yfo|yfp|yfd|yfg|yfh|yfj|yfk|yfl|yfz|yfx|yfc|yfv|yfb|yfn|yf[|yf:|yf;|yf,|yf.|ygt|ygf|ygh|yhe|yhf|yhb|yjq|yjw|yje|yjr|yjt|yjy|yju|yji|yjo|yjp|yja|yjd|yjf|yjg|yjh|yjj|yjk|yjl|yjz|yjx|yjc|yjv|yjb|yjn|yj[|yj:|yj;|yj,|yj.|ykz|ylt|ylp|yls|yld|ylf|ylh|ylj|ylk|ylc|ylb|yln|yl;|yl,|yl.|yzq|yzr|yzt|yzy|yzu|yzo|yzp|yzd|yzk|yzz|yzx|yzc|yzv|yzn|yz[|yz:|yz;|yz,|yz.|yxt|yxf|yxk|yxb|yx.|ycw|ycr|yct|yca|ycs|ycf|ycg|ycj|yck|ycb|ycn|yc,|yc.|yvt|yvb|ybq|ybw|ybt|yby|ybu|ybi|ybp|yba|ybf|ybg|ybh|ybj|ybk|ybl|ybz|ybx|ybc|ybv|ybb|ybn|yb[|yb:|yb;|yb,|yb.|ynr|yny|ynu|yns|ynf|ynh|ynj|ynk|ynz|ynb|yn.|ymr|ymt|ymu|ymj|ymz|ymc|ym:|ym;|ym.|y[t|y[u|y[f|y[h|y[j|y[b|y]t|y].|y{,|y{.|y;t|y;f|y;b|y,e|y,t|y,f|y,h|y,j|y,k|y.i|y.o|y.f|y.l|y.x|y.c|y.[|y.:|y.,|y..|uei|uep|ueg|urj|utq|utj|utk|utv|uyt|uyf|uyj|uyz|uyb|uut|upf|uah|udf|udj|udb|ufq|ufw|ufe|ufy|ufp|ufd|ufg|ufh|ufk|ufz|ufx|ufc|ufv|ufb|ufn|uf[|uf:|uf;|uf,|uf.|uhe|uht|uhs|uhf|uhj|uhz|uhb|uh,|ujq|ujw|uje|ujr|ujt|ujy|uju|ujo|ujp|uja|ujd|ujg|ujh|ujj|ujk|ujl|ujx|ujc|ujv|ujb|ujn|uj[|uj:|uj;|uj,|uj.|ukt|uks|ukf|ukj|ukz|ukb|uxf|uxb|ucz|ucn|uc,|uvt|uvs|uvf|uv,|uv.|ubq|ubp|ubg|ubh|ubk|ubz|ubx|ubc|ubn|ub[|ub:|ub.|unz|u;t|u<,|u,t|u,f|u,b|u..|iwt|iws|iw,|ieq|iei|ieo|ieh|iex|ie[|irf|irj|itq|itp|itd|itg|itx|itv|itb|it[|iye|iyt|iys|iyf|iyj|iyz|iyb|iy.|iuh|idf|idj|ifq|ifd|ifg|ifh|ifk|ifz|ifc|ifv|ifn|if[|if;|if.|igf|igj|ihe|ihf|ihb|ijq|ije|ijr|ijt|ijy|iju|ijd|ijg|ijh|ijx|ijc|ijv|ijn|ij:|ij,|ij.|ikt|iks|ikf|ikj|ikz|ikb|ixf|ivt|ivf|ivz|ibq|ibw|ibt|ibo|ibp|ibd|ibg|ibh|ibk|ibz|ibc|ibv|ib[|imt|imz|imc|i.h|i.n|i..|oeo|oeg|oeh|oex|oec|otq|otd|otg|otk|otx|otv|otn|ot:|oyt|oyj|oyb|ofq|ofd|ofz|ofc|ofv|ofn|of[|oht|ohz|ojv|oj,|obq|obw|obg|obk|obx|ob[|ob:|pwe|pwt|pwj|peq|pey|peh|pek|pe[|prt|prf|prj|prb|ptq|ptw|ptt|ptd|ptk|ptz|ptv|pye|pyt|pys|pyf|pyj|pyz|pyb|pym|puy|puh|puj|puk|pu,|pu.|pib|ppd|ppf|pph|ppk|ppb|psq|psr|psd|psx|psv|pde|pdt|pdy|pds|pdf|pdh|pdj|pdk|pdz|pdb|pfq|pfw|pfe|pfr|pft|pfy|pfi|pfp|pfd|pff|pfg|pfh|pfj|pfk|pfl|pfz|pfx|pfc|pfv|pfb|pfn|pf[|pf:|pf;|pf,|pf.|pgj|pht|phf|phj|phz|phb|pjq|pjr|pjy|pju|pji|pjo|pjp|pja|pjd|pjg|pjh|pjj|pjk|pjl|pjx|pjc|pjv|pjn|pj,|pkt|pku|pks|pkf|pkj|pkz|pkb|pk:|pk,|pk.|plr|plt|pls|pld|plf|plh|plj|plz|plb|plm|pl:|pl,|pl.|pzq|pzr|pzt|pzo|pzd|pzk|pzv|pzb|pzn|pz,|pz.|pxt|pxf|pxb|pcr|pck|pve|pvt|pvy|pvs|pvf|pvj|pvz|pvb|pv,|pv.|pbq|pbw|pbt|pby|pbu|pbi|pbd|pbf|pbh|pbj|pbk|pbl|pbz|pbx|pbc|pbv|pbb|pbn|pb:|pb;|pb,|pb.|pnb|pnm|pmt|pmz|pmv|pmn|pm:|pm,|pm.|p]t|p]z|p;e|p;t|p;f|p;b|p,e|p,t|p,s|p,f|p,h|p,j|p,b|p,.|p.l|p.v|p.n|p.,|p..|aey|aeh|atq|atd|atj|atk|atv|ayj|aat|aaj|aab|aa,|aa.|afq|afp|afd|afh|afk|afz|afc|afv|af[|aht|ahf|ahj|ahb|ajq|ajy|ajp|ajh|ajk|ajx|ajc|ajv|ajn|aj,|akt|akj|akz|akb|azr|azn|axb|ac<|avt|avf|abw|abt|abp|abf|abk|abz|abx|abc|amz|a.v|a..|sql|sqn|sq:|sq,|swt|swf|srt|sry|sri|srf|srh|srj|srk|srb|sr.|st[|syt|syy|syf|syj|syz|syx|suy|suh|suj|siw|siy|sij|si.|spt|spd|spf|spj|sp;|sdr|sdt|sdy|sds|sdf|sdj|sdx|sdb|sd,|sd.|sge|sgt|sgy|sgs|sgf|sgh|sgj|sgk|sgz|sgb|sgm|shs|shd|shj|shz|shx|skt|skf|skj|skz|skc|skb|skm|slt|sld|slf|slh|slj|slk|slb|sl,|sl.|szd|szc|sxe|sxr|sxt|sxy|sxf|sxk|sxb|sx,|scw|sct|scs|scd|scf|scg|scj|sck|scz|scx|scv|scb|scn|scm|sc[|sc.|svt|svy|svs|svf|svj|svk|svz|svx|svc|svb|sv:|sv,|sv.|sbc|snw|snr|snt|sny|sns|snd|snf|snh|snj|snk|snz|snc|snb|snm|sn,|sn.|s[e|s[t|s[y|s[f|s[j|s[k|s[b|s[n|s[:|s[,|s[.|s;e|s;r|s;t|s;y|s;f|s;j|s;l|s;v|s;b|s;;|s;,|s,e|s,r|s,t|s,y|s,s|s,f|s,h|s,j|s,k|s,z|s,x|s,b|s,m|s,.|s..|dqj|dwt|dws|dwf|dwj|dek|de[|drt|drf|drh|drj|drk|drb|dtq|dtw|dtt|dty|dtu|dtp|dtd|dtg|dtj|dtk|dtl|dtz|dtx|dtc|dtv|dtn|dt[|dt:|dt;|dt,|dt.|dyu|dyf|dyj|dyz|dyb|duj|dob|dpy|dpu|dps|dpd|dpf|dph|dpj|dpk|dpl|dpz|dpv|dpb|dp]|dp,|dsq|dsy|dsd|dsg|dsk|dsz|dsx|dsv|dsb|ds[|ddt|ddf|ddj|ddz|ddc|ddb|dfq|dfw|dft|dfy|dfp|dfd|dfh|dfk|dfz|dfx|dfc|dfv|dfb|dfn|df[|df:|df;|df,|df.|dgt|dgf|dgh|dgj|dgk|dgb|dht|dhs|dhf|dhj|dhz|dhb|dh,|dh.|djq|djw|djr|djt|djy|djp|djd|djg|djh|djj|djk|djl|djz|djx|djc|djv|djb|djn|dj[|dj:|dj;|dj<|dj,|dj.|dkt|dkf|dkj|dkz|dkb|dkn|dk.|dlt|dls|dld|dlf|dlh|dlj|dlb|dzr|dzy|dzi|dzo|dzp|dzk|dzl|dzc|dzv|dzn|dz;|dxt|dxf|dxj|dxb|dce|dct|dcs|dcf|dcg|dcj|dck|dcz|dcv|dcn|dc[|dc.|dvt|dvf|dvj|dvb|dbq|dbw|dbr|dbt|dbu|dbp|dbd|dbf|dbh|dbk|dbz|dbx|dbc|dbv|dbb|dbn|db[|db;|db,|db.|dns|dnf|dnh|dnj|dnz|dnb|dn,|dmt|dmz|dmc|dmb|dmn|dm,|dm.|d[f|d[j|d]t|d{j|d;f|d,t|d,k|d,b|d.h|d..|fqw|fqr|fqt|fqy|fqu|fqi|fqp|fqd|fqh|fqj|fqk|fql|fqx|fqc|fqv|fqb|fqn|fq:|fq,|fq.|fwe|fwr|fwt|fwy|fwf|fwl|fwb|fw,|fw.|feh|fek|fex|frw|frr|frt|frd|frf|frh|frj|frk|frl|frx|frc|frb|frn|fr[|fr:|fr;|fr,|fr.|ftq|ftr|ftd|ftg|ftx|ftv|ft[|fyw|fye|fyr|fyt|fyy|fyu|fyp|fys|fyf|fyg|fyj|fyl|fyz|fyx|fyc|fyb|fyn|fym|fy[|fy:|fy;|fuy|fuu|fuh|fuj|fuk|fuv|fub|fu:|fu,|fu.|fiw|fiy|fij|fik|fim|fi,|fi.|fot|fof|foj|fob|fo.|fpw|fpr|fpt|fpy|fpu|fpp|fps|fpd|fpf|fph|fpj|fpk|fpl|fpx|fpc|fpv|fpb|fpm|fp]|fp:|fp;|fp,|fp.|fae|faf|fah|faj|fax|fsy|fdw|fde|fdr|fdt|fdy|fdu|fdi|fdp|fds|fdd|fdf|fdh|fdj|fdk|fdl|fdz|fdx|fdc|fdv|fdb|fdn|fdm|fd:|fd,|fd.|ffg|ffv|ff[|fge|fgr|fgt|fgy|fgi|fgs|fgf|fgg|fgh|fgj|fgk|fgz|fgc|fgb|fgn|fgm|fg,|fg.|fhw|fhe|fhr|fht|fhy|fhu|fhi|fho|fhs|fhd|fhf|fhg|fhh|fhj|fhk|fhl|fhz|fhx|fhc|fhv|fhb|fhn|fhm|fh[|fh:|fh;|fh,|fh.|fjr|fjy|fjg|fjh|fjl|fjc|fj,|fj.|fke|fkt|fku|fka|fks|fkf|fkg|fkj|fkk|fkl|fkz|fkx|fkc|fkv|fkb|fkn|fkm|fk[|fk:|fk;|fk,|fk.|flw|flr|flt|flp|fls|fld|flf|flg|flh|flj|flk|flz|flx|flc|flv|flb|fln|flm|fl]|fl:|fl;|fl,|fl.|fzw|fzr|fzy|fzd|fzk|fzl|fzx|fzc|fzn|fz[|fz:|fz,|fz.|fxe|fxr|fxt|fxy|fxu|fxf|fxg|fxj|fxk|fxx|fxb|fxm|fx,|fx.|fcw|fce|fcr|fct|fcy|fci|fco|fca|fcs|fcd|fcf|fcg|fcj|fck|fcz|fcx|fcc|fcv|fcb|fcn|fcm|fc[|fc;|fc,|fc.|fvw|fve|fvr|fvt|fvy|fvi|fvs|fvd|fvf|fvg|fvh|fvj|fvk|fvz|fvx|fvc|fvv|fvb|fvm|fv:|fv,|fv.|fbr|fby|fbu|fbi|fbp|fbd|fbk|fbx|fbc|fbv|fbn|fb,|fb.|fnw|fnr|fnt|fny|fna|fns|fnd|fnf|fnh|fnj|fnk|fnz|fnx|fnc|fnv|fnb|fnn|fnm|fn[|fn:|fn,|fn.|f[e|f[t|f[y|f[d|f[f|f[h|f[j|f[k|f[c|f[v|f[b|f[n|f[:|f[,|f[.|f;e|f;r|f;t|f;y|f;f|f;h|f;j|f;l|f;c|f;v|f;b|f;m|f;,|f;.|f,e|f,r|f,t|f,y|f,p|f,s|f,d|f,f|f,h|f,j|f,k|f,c|f,b|f,m|f,;|f,,|f,.|f.r|f.o|f.x|f.c|f.n|f.:|f..|gws|gwf|gwj|gwb|gei|geg|geh|gek|gex|gec|ge[|grt|grf|grj|grb|gtq|gtw|gtr|gtt|gty|gtu|gtp|gtd|gtg|gtk|gtl|gtz|gtx|gtc|gtn|gt[|gt,|gt.|gye|gyt|gys|gyf|gyj|gyz|gyb|gaf|gsq|gsd|gsx|gsv|gsn|gs[|gfq|gfw|gfe|gfr|gft|gfy|gfi|gfp|gfa|gfd|gfg|gfh|gfk|gfl|gfz|gfx|gfc|gfv|gfb|gfn|gf[|gf{|gf;|gf,|gf.|ggt|ggf|ggj|ggb|ghh|ghj|ghz|gjq|gjw|gje|gjr|gjt|gjy|gju|gji|gjo|gjp|gja|gjd|gjf|gjg|gjh|gjj|gjk|gjl|gjz|gjx|gjc|gjv|gjb|gjn|gj[|gj:|gj;|gj,|gj.|gke|gkt|gks|gkf|gkj|gkz|gkb|gkm|gk.|gzo|gzh|gzk|gzl|gzx|gzc|gzn|gz[|gxe|gxt|gxf|gxb|gce|gcr|gct|gcs|gcf|gcj|gcb|gvf|gbq|gbw|gbr|gbt|gby|gbu|gbi|gbp|gbd|gbf|gbh|gbj|gbk|gbl|gbz|gbx|gbc|gbv|gbn|gb[|gb:|gb;|gb,|gb.|gnt|gnf|gnj|gnz|gnb|gmt|gmz|gm,|gm.|g,t|g.i|g.g|g.h|hwt|hws|hwf|hwj|hwb|hw.|heq|hez|hex|he[|hrt|hrd|hrf|hrj|hrc|hrv|hrb|hrn|hr:|hr,|htq|htp|htd|htg|htj|htk|htz|htx|htc|htv|ht[|ht<|hye|hyu|hyf|hyj|hyz|hyc|hy[|huy|hui|huj|hu.|hiy|hih|hij|hi,|hi.|hpr|hpt|hpy|hps|hpd|hpf|hpj|hpk|hpb|hpm|hp,|hp.|hsq|hsw|hsr|hsy|hsu|hsi|hsp|hsd|hsk|hsl|hsx|hsc|hsv|hsn|hs[|hde|hdt|hds|hdf|hdj|hdz|hdb|hdm|hfq|hfw|hfe|hfr|hft|hfy|hfi|hfo|hfp|hfd|hff|hfg|hfh|hfj|hfk|hfz|hfx|hfc|hfv|hfb|hfn|hf[|hf:|hf;|hf,|hf.|hge|hgr|hgt|hgy|hgs|hgf|hgh|hgj|hgk|hgz|hgb|hgn|hg,|hg.|hht|hhf|hhh|hhj|hhb|hjq|hjw|hje|hjr|hjt|hjy|hju|hji|hjo|hjp|hja|hjd|hjf|hjg|hjh|hjj|hjk|hjl|hjz|hjx|hjc|hjv|hjb|hjn|hj[|hj:|hj;|hj<|hj,|hj.|hke|hkt|hkp|hks|hkf|hkj|hkz|hkb|hkm|hk,|hk.|hlw|hlt|hls|hlf|hlj|hll|hlz|hlc|hlb|hl;|hl,|hl.|hzq|hzw|hzr|hzt|hzy|hzu|hzi|hzo|hzp|hzd|hzg|hzk|hzl|hzz|hzx|hzc|hzv|hzn|hz[|hz:|hz;|hz,|hz.|hxe|hxr|hxt|hxf|hxb|hx,|hx.|hce|hct|hcy|hcs|hcf|hcg|hcj|hcz|hcv|hcb|hcn|hc,|hc.|hve|hvt|hvi|hvs|hvf|hvj|hvk|hvz|hvc|hvb|hv,|hv.|hbq|hbw|hbt|hby|hbp|hbd|hbf|hbg|hbh|hbj|hbk|hbl|hbz|hbx|hbc|hbv|hbb|hbn|hb[|hb:|hb;|hb,|hb.|hnr|hnt|hny|hns|hnd|hnf|hnh|hnj|hnz|hnc|hnm|hn;|hmr|hmt|hmu|hmz|hmc|hmv|hmb|hmn|hm:|h[e|h[t|h[y|h[d|h[f|h[j|h[l|h[x|h[b|h[]|h[,|h[.|h;w|h;e|h;r|h;t|h;y|h;f|h;j|h;l|h;b|h;.|h,e|h,t|h,y|h,f|h,h|h,j|h,k|h,b|h,,|h,.|h.r|h.y|h.u|h.p|h.k|h.z|h.x|h.c|h.v|h.n|h.[|h.:|h.,|h..|jqw|jqr|jqt|jqy|jqj|jqk|jql|jqx|jqc|jqv|jqn|jq:|jq,|jq.|jwr|jwt|jwd|jwf|jwb|jey|jed|jeg|jeh|jek|jex|jev|jeb|je[|je;|je.|jre|jrr|jrt|jry|jru|jri|jrp|jrd|jrf|jrh|jrj|jrk|jrc|jrb|jrn|jr:|jr,|jtq|jtw|jtr|jty|jtu|jti|jtp|jtd|jtg|jtj|jtk|jtl|jtx|jtc|jtv|jtn|jt[|jt:|jt;|jt,|jt.|jyw|jye|jyr|jyt|jyy|jyu|jyi|jyo|jyp|jya|jys|jyd|jyf|jyg|jyh|jyj|jyl|jyz|jyx|jyc|jyb|jyn|jym|jy[|jy]|jy:|jy,|jy.|juy|juf|juh|juj|juk|juc|ju:|ju,|ju.|jie|jir|jiy|jid|jif|jij|jik|jiv|ji.|joe|jof|jom|jpw|jpe|jpr|jpt|jpy|jpu|jpp|jps|jpd|jpf|jph|jpj|jpk|jpl|jpz|jpx|jpv|jpb|jpm|jp:|jp;|jp,|jae|jat|jaa|jah|jaj|jak|jdw|jde|jdr|jdt|jdy|jdi|jdo|jdp|jds|jdf|jdg|jdh|jdj|jdk|jdl|jdz|jdx|jdc|jdv|jdb|jdn|jdm|jd:|jd,|jd.|jfr|jfy|jfp|jfa|jfd|jfg|jfh|jfk|jfn|jge|jgr|jgt|jgy|jgi|jgs|jgf|jgg|jgh|jgj|jgk|jgz|jgx|jgc|jgb|jgn|jgm|jg,|jg.|jhw|jhe|jhr|jht|jhy|jhu|jhi|jho|jhp|jha|jhs|jhd|jhf|jhg|jhh|jhj|jhk|jhl|jhz|jhx|jhc|jhv|jhb|jhn|jhm|jh[|jh:|jh;|jh,|jh.|jjw|jjy|jjo|jjg|jjh|jjl|jjx|jjc|jjn|jj[|jj.|jke|jkr|jkt|jky|jku|jki|jko|jkp|jks|jkd|jkf|jkg|jkj|jkk|jkl|jkz|jkx|jkc|jkv|jkb|jkn|jkm|jk[|jk;|jk,|jk.|jlw|jle|jlr|jlt|jly|jlu|jli|jlp|jls|jld|jlf|jlg|jlh|jlj|jlk|jll|jlz|jlx|jlc|jlv|jlb|jln|jlm|jl[|jl]|jl;|jl,|jl.|jzr|jzy|jzo|jzp|jzd|jzh|jzk|jzl|jzc|jzv|jzn|jz[|jz:|jz;|jz,|jz.|jxe|jxr|jxt|jxy|jxd|jxf|jxj|jxk|jxb|jxn|jxm|jx,|jcw|jce|jcr|jct|jcy|jci|jca|jcs|jcd|jcf|jcg|jch|jcj|jck|jcz|jcx|jcc|jcv|jcb|jcn|jcm|jc[|jc:|jc,|jc.|jvw|jve|jvr|jvt|jvy|jvo|jva|jvs|jvd|jvf|jvg|jvh|jvj|jvk|jvz|jvx|jvc|jvv|jvb|jvn|jvm|jv:|jv;|jv<|jv,|jv.|jbw|jby|jbu|jbi|jbo|jbp|jbd|jbh|jbk|jbl|jbx|jbc|jbv|jbn|jb[|jb,|jb.|jnw|jne|jnr|jnt|jny|jnu|jni|jno|jnp|jna|jns|jnd|jnf|jng|jnh|jnj|jnk|jnl|jnz|jnx|jnc|jnv|jnb|jnn|jnm|jn[|jn]|jn:|jn;|jn,|jn.|j[e|j[t|j[y|j[i|j[d|j[f|j[h|j[j|j[k|j[b|j[n|j[:|j[,|j[.|j:y|j;e|j;r|j;t|j;y|j;u|j;f|j;h|j;j|j;l|j;v|j;b|j;m|j;:|j;;|j;,|j;.|j<f|j<j|j,e|j,r|j,t|j,y|j,u|j,i|j,o|j,p|j,a|j,s|j,d|j,f|j,h|j,j|j,k|j,l|j,z|j,c|j,v|j,b|j,n|j,m|j,[|j,]|j,:|j,;|j,,|j,.|j.e|j.t|j.o|j.p|j.h|j.l|j.c|j.n|j.:|j.,|j..|keq|keu|kea|keh|kej|kek|kex|kec|kev|keb|ke[|krt|krf|krj|krk|krb|kr,|kr.|ktq|ktw|kte|ktr|ktt|kty|ktu|kti|ktp|kta|ktd|ktf|ktg|kth|ktj|ktk|ktl|ktz|ktx|ktc|ktv|ktb|ktn|kt:|kt;|kt,|kt.|kye|kyt|kys|kyf|kyj|kyz|kyb|kut|kuf|kuj|kuk|kub|ku,|ku.|kii|koe|kpt|kpy|kpf|kpk|kpn|kaf|ksr|ksy|ksd|ksk|ksx|ksc|ksv|ksn|ks[|kdr|kdt|kdy|kds|kdf|kdc|kdb|kfq|kfw|kfe|kfr|kft|kfy|kfo|kfp|kfd|kfg|kfh|kfk|kfl|kfz|kfx|kfc|kfv|kfb|kfn|kf[|kf:|kf;|kf,|kf.|kge|kgt|kgs|kgf|kgj|kgb|kjq|kjw|kje|kjr|kjt|kjy|kju|kji|kjo|kjp|kja|kjd|kjg|kjh|kjj|kjk|kjl|kjz|kjx|kjc|kjv|kjb|kjn|kj[|kj:|kj;|kj,|kj.|kkt|kkp|kks|kkf|kkj|kkz|kkb|kkm|kk,|kk.|klt|kls|kld|klf|klj|kl.|kzq|kzw|kze|kzr|kzt|kzy|kzu|kzi|kzo|kzp|kzd|kzg|kzh|kzk|kzl|kzz|kzx|kzc|kzv|kzn|kz[|kz:|kz;|kz,|kz.|kxe|kxr|kxt|kxy|kxf|kxj|kxb|kxm|kct|kcj|kck|kcz|kcn|kvt|kvs|kvf|kvj|kvb|kv,|kbq|kbw|kbt|kby|kbu|kbp|kbd|kbf|kbg|kbh|kbj|kbk|kbl|kbz|kbx|kbc|kbv|kbb|kbn|kb[|kb:|kb;|kb,|kb.|knt|kns|knf|knj|knk|knb|kn.|kmw|kmr|kmt|kmy|kmu|kmi|kmo|kmp|kmd|kmg|kmh|kmj|kml|kmz|kmx|kmc|kmv|kmb|kmn|km:|km<|km,|km.|k[j|k[b|k;t|k;y|k;f|k;b|k>l|k>x|k,e|k,t|k,s|k,f|k,j|k,k|k,b|k,.|k.q|k.w|k.r|k.y|k.u|k.i|k.o|k.p|k.a|k.d|k.g|k.h|k.k|k.l|k.x|k.c|k.v|k.n|k.[|k.:|k.;|k.,|k..|lwe|lwt|lwf|lwj|leu|lek|le[|lrt|lrf|lrh|lrj|lrk|lrb|ltq|ltw|ltt|ltp|ltd|ltf|ltg|ltj|ltk|ltx|ltc|ltv|ltb|ltn|lyj|lyb|ly{|luh|luj|lpy|lpj|lpb|lsq|lsr|lsy|lsd|lsh|lsl|lsx|lsc|lsv|ls[|ldt|ldp|ldj|ldk|lfq|lfy|lfg|lfh|lfk|lfl|lfz|lfx|lfc|lfv|lfn|lf[|lgt|lgf|lgh|lgj|lgk|lgb|lht|lhy|lhs|lhf|lhj|lhz|lhc|lhb|lh,|lh.|ljq|ljw|lje|ljr|ljt|ljy|lju|lji|ljo|ljp|ljd|ljf|ljg|ljh|ljj|ljk|ljl|ljx|ljc|ljv|ljb|ljn|lj[|lj;|lj,|lj.|lkt|lkf|lkj|lkz|lk]|llj|lzt|lzy|lzu|lzo|lzl|lzx|lzc|lzv|lzn|lz[|lz:|lz;|lz,|lz.|lxe|lxt|lxf|lxb|lcd|lcf|lcj|lck|lcx|lcv|lcb|lcn|lvt|lvs|lvf|lvj|lvb|lbq|lbw|lbt|lby|lbi|lbp|lbd|lbf|lbg|lbh|lbj|lbk|lbl|lbz|lbx|lbc|lbv|lbb|lbn|lb:|lb,|lb.|lnt|lnd|lnf|lnh|lnj|lnz|lnc|lnb|ln,|lmr|lmt|lmz|lmv|l[d|l[f|l[j|l]t|l]z|l].|l;e|l;t|l;f|l;j|l;b|l;,|l;.|l,t|l,f|l,h|l,j|l,b|l.q|l.r|l.i|l.g|l.c|l.;|l..|zqw|zqr|zqc|zqn|zq,|zq.|zwt|zws|zwf|zwb|zw,|zw.|zep|zre|zrt|zry|zri|zrd|zrf|zrj|zrk|zrc|zrb|zr,|zr.|zti|ztd|ztv|ztn|zyw|zye|zyr|zyt|zyy|zyu|zyo|zys|zyd|zyf|zyj|zyl|zyz|zyx|zyc|zyb|zyn|zym|zue|zut|zuy|zui|zuf|zuj|zuk|zux|zuc|zub|zu,|zir|ziy|zik|zoe|zoy|zof|zob|zpr|zpt|zpy|zpu|zps|zpd|zpf|zpk|zpz|zpx|zpb|zpm|zp.|zde|zdr|zdy|zdi|zds|zdf|zdj|zdk|zdz|zdc|zdb|zd,|zge|zgr|zgy|zgf|zgh|zgj|zgb|zhr|zht|zhy|zhs|zhf|zhj|zhl|zhx|zhc|zhv|zhb|zh,|zkr|zks|zkf|zkj|zkz|zkc|zkb|zkn|zkm|zk:|zk,|zk.|zlr|zlt|zly|zls|zlf|zlh|zlj|zlk|zlz|zlb|zlm|zl,|zl.|zzc|zzv|zz:|zz,|zxe|zxr|zxt|zxy|zxf|zxj|zxb|zxm|zx,|zx.|zce|zcr|zct|zcy|zcs|zcf|zcj|zck|zcz|zcc|zcb|zcn|zcm|zc,|zc.|zvw|zve|zvt|zvo|zvs|zvf|zvj|zvk|zvc|zvb|zvm|zv:|zv,|zv.|zbw|zby|zbx|znw|znr|znt|zny|zns|znf|znj|znk|znz|znc|znb|znm|zn:|zn,|zn.|z[y|z[k|z[b|z[n|z[:|z[,|z[.|z;e|z;r|z;t|z;y|z;f|z;x|z;b|z;,|z;.|z,r|z,i|z,f|z,h|z,k|z,b|z,,|z,.|z.o|z.c|z.n|z.:|z.,|z..|xet|xei|xeo|xeh|xek|xel|xez|xex|xev|xe[|xe:|xre|xrt|xrf|xrj|xrb|xr,|xtq|xtt|xtp|xtd|xtg|xtk|xtl|xtz|xtx|xtc|xtv|xtn|xt[|xt:|xye|xyt|xyf|xyj|xyz|xyb|xue|xif|xde|xdt|xds|xdf|xfq|xfr|xft|xfy|xfu|xfi|xfd|xfh|xfk|xfl|xfz|xfc|xfv|xfb|xfn|xf[|xf:|xf,|xf.|xgf|xg.|xht|xjr|xjy|xjg|xjh|xjv|xj:|xj,|xj.|xkt|xkf|xkb|xxb|xvj|xbq|xbw|xbr|xbt|xby|xbu|xbi|xbo|xbp|xbd|xbh|xbj|xbk|xbz|xbx|xbc|xbv|xbb|xbn|xb[|xb{|xb;|xb,|xb.|xne|xnt|xns|xnf|xnj|xnz|xnb|xmt|xmz|xmc|xmb|xm:|xm,|xm.|x[j|x..|cwt|cws|cwd|cwf|cwj|cwb|ceq|cey|ceu|ceo|ceh|cek|cez|cex|cev|ce[|crt|crd|crf|crh|crj|crk|crb|crm|cr:|cr,|cr.|ctq|ctw|ctt|cty|ctp|ctd|ctg|cth|ctj|ctk|ctz|ctx|ctc|ctv|ctb|ct[|cye|cyf|cyj|cyz|cyb|cuh|cuj|cuk|ciy|cpf|csq|csr|csy|csu|csd|csg|csh|csk|csc|csv|csn|cs[|cs:|cdt|cds|cdf|cdj|cdz|cdb|cd.|cfq|cfe|cfr|cft|cfy|cfi|cfa|cfd|cff|cfg|cfh|cfk|cfl|cfz|cfx|cfc|cfv|cfn|cf[|cf;|cf,|cf.|cge|cgt|cgs|cgf|cgh|cgj|cgk|cgz|cgb|chj|cjq|cjw|cje|cjr|cjt|cjy|cju|cji|cjp|cja|cjd|cjg|cjh|cjj|cjk|cjl|cjx|cjc|cjv|cjb|cjn|cj[|cj;|cj,|cj.|ckt|ckj|ckz|clt|cld|clf|clj|clb|czw|czr|czu|czo|czp|czl|czx|czc|czv|czn|cz[|cz:|cz;|cz,|cz.|cxe|cxt|cxf|cxk|cxb|cct|ccy|ccs|ccd|ccf|ccg|ccj|cck|ccz|ccx|ccc|ccv|ccb|ccn|cc:|cc,|cc.|cve|cvt|cvs|cvf|cvh|cvj|cvz|cvb|cbq|cbw|cbr|cbt|cby|cbu|cbi|cbo|cba|cbd|cbf|cbg|cbh|cbj|cbk|cbl|cbz|cbx|cbc|cbv|cbb|cbn|cb[|cb{|cb;|cb,|cb.|cnq|cne|cnr|cnt|cny|cna|cns|cnd|cnf|cnh|cnj|cnk|cnz|cnx|cnc|cnv|cnb|cnm|cn:|cn,|cn.|cmt|cmj|cmz|cmv|cmn|cm:|cm,|cm.|c[e|c[t|c[d|c[f|c[h|c[j|c[k|c[b|c[n|c]t|c]z|c;t|c;f|c;b|c<t|c,e|c,t|c,s|c,f|c,h|c,j|c,k|c,b|c.r|c.h|c.l|c.c|c.b|c..|vwe|vwt|vws|vwf|vwj|veu|veo|vep|vek|vev|veb|ve[|vrt|vry|vrf|vrj|vrb|vtq|vtw|vtr|vtt|vty|vtu|vti|vto|vtp|vtd|vth|vtk|vtl|vtz|vtx|vtc|vtv|vtb|vtn|vt[|vt:|vt;|vt,|vt.|vye|vyt|vys|vyf|vyj|vyz|vyb|vue|vuy|vuk|vaf|vsq|vsr|vst|vsy|vsi|vso|vsp|vsd|vsx|vsc|vsv|vsn|vs[|vdt|vdf|vdj|vdl|vfq|vfw|vfe|vfr|vft|vfy|vfu|vfi|vfp|vfa|vfd|vfh|vfk|vfl|vfz|vfx|vfc|vfv|vfn|vf[|vf:|vf;|vf,|vf.|vge|vgt|vgs|vgf|vgh|vgj|vgk|vgb|vgn|vgm|vg,|vhe|vht|vhf|vhb|vjq|vjw|vje|vjr|vjt|vjy|vju|vji|vjo|vjp|vja|vjd|vjg|vjh|vjj|vjk|vjl|vjz|vjx|vjc|vjv|vjb|vjn|vj[|vj:|vj;|vj,|vj.|vkt|vkf|vkz|vkx|vkb|vkm|vk.|vzr|vzy|vzu|vzo|vzd|vzg|vzk|vzx|vzc|vzv|vzn|vz,|vz.|vxe|vxt|vxf|vxb|vcr|vcf|vcj|vcz|vcc|vcn|vcm|vve|vvr|vvt|vvs|vvf|vvj|vvv|vvb|vv<|vv.|vbq|vbw|vbr|vbt|vby|vbu|vbi|vbo|vbp|vba|vbd|vbh|vbk|vbl|vbz|vbx|vbc|vbv|vbb|vbn|vb[|vb:|vb,|vb.|vnt|vnz|vnb|vmt|vml|vmz|vmc|vmb|vmn|vm,|vm.|v[f|v[j|v;f|v;,|v<s|v<b|v,e|v,t|v,s|v,f|v,h|v,j|v,k|v,b|v,m|v,,|v,.|v.w|v.y|v.h|v.b|v..|bqw|bqr|bqy|bqc|bqn|bq:|bq,|bq.|bww|bwe|bwr|bwt|bws|bwd|bwf|bwj|bwb|bw,|bw.|beu|bex|brw|brt|brd|brf|brh|brj|brk|brx|brc|brb|brn|br:|br.|btq|btw|bty|btp|btd|bth|btc|btv|btn|bt[|bt:|byy|byu|byp|byd|byf|byj|byk|byx|byc|byb|byn|bym|by[|by]|bup|bua|buh|buj|buv|bu,|bu.|biy|biu|bif|bij|bik|bim|bi,|boe|bof|boh|bo.|bpe|bpr|bpt|bpy|bpu|bpi|bpp|bpa|bps|bpd|bpf|bpg|bph|bpj|bpk|bpl|bpz|bpc|bpv|bpb|bpm|bp]|bp;|bp,|bp.|baa|bav|bdw|bde|bdt|bdy|bds|bdf|bdh|bdj|bdk|bdz|bdx|bdc|bdb|bdm|bd:|bd,|bd.|bfw|bfr|bfy|bfu|bfp|bfd|bfg|bfh|bfk|bfl|bfc|bfv|bfn|bge|bgr|bgt|bgy|bgi|bgs|bgf|bgg|bgh|bgj|bgk|bgz|bgc|bgb|bgn|bg,|bg.|bhe|bhr|bht|bhy|bhu|bhi|bhs|bhf|bhg|bhh|bhj|bhk|bhz|bhx|bhc|bhv|bhb|bhn|bhm|bh:|bh;|bh,|bh.|bjr|bjy|bjp|bjd|bjf|bjg|bjk|bjl|bjc|bjn|bj[|bj,|bj.|bke|bkr|bkt|bks|bkf|bkj|bkk|bkl|bkz|bkc|bkb|bkn|bkm|bk:|bk,|bk.|blw|blr|blt|bls|bld|blf|blh|blj|blz|blx|blc|blb|bln|bl;|bl,|bl.|bzq|bzt|bzy|bzp|bzd|bzk|bzz|bzx|bzv|bzn|bz[|bz:|bz;|bz,|bz.|bxe|bxr|bxt|bxy|bxf|bxj|bxx|bxb|bxn|bxm|bx,|bx.|bcw|bce|bcr|bct|bcy|bci|bca|bcs|bcf|bcg|bcj|bck|bcl|bcz|bcx|bcc|bcv|bcb|bcn|bcm|bc[|bc,|bc.|bvr|bvt|bvy|bva|bvs|bvd|bvf|bvg|bvj|bvz|bvx|bvc|bvv|bvb|bv:|bv,|bv.|bbh|bbc|bbv|bb:|bb,|bb.|bnr|bnt|bny|bns|bnd|bnf|bnh|bnj|bnk|bnz|bnx|bnc|bnv|bnb|bnn|bnm|bn:|bn,|bn.|bmw|b[e|b[t|b[y|b[i|b[d|b[f|b[h|b[j|b[k|b[c|b[b|b[n|b[:|b[,|b[.|b{y|b{j|b:c|b;e|b;r|b;t|b;y|b;f|b;j|b;l|b;c|b;v|b;b|b;,|b;.|b,e|b,r|b,t|b,y|b,i|b,a|b,s|b,f|b,h|b,j|b,k|b,c|b,b|b,,|b,.|b.y|b.k|b.n|b.:|b.,|b..|nqd|nwt|nws|nwf|nwj|nw,|nek|ne[|nrt|nrf|nrh|nrj|nrk|nrb|ntq|ntt|ntp|ntd|ntg|ntj|ntk|ntx|ntc|ntv|nt[|nye|nys|nyf|nyj|nyz|nuh|nuj|nps|npj|naj|nsq|nsr|nsy|nsd|nsx|nsv|ns[|ndz|nfq|nfw|nft|nfy|nfp|nfd|nfg|nfh|nfk|nfz|nfx|nfc|nfv|nfb|nfn|nf[|nf:|nf;|nf,|nf.|ngj|ngk|nht|nhs|nhf|nhj|nhl|nhz|nhb|nhm|nh,|nh.|njq|njw|njr|njt|njy|nji|njp|njd|njf|njg|njh|njj|njk|njl|njz|njx|njc|njv|njb|njn|nj[|nj:|nj;|nj,|nj.|nkj|nkz|nkb|nlt|nls|nlf|nlj|nlb|nzq|nzr|nzu|nzp|nzg|nzh|nzx|nzc|nzv|nzn|nz[|nz;|nz,|nz.|nxt|nxf|nxb|ncs|ncd|ncf|ncj|nck|ncz|ncx|ncv|ncb|ncn|nc.|nvt|nvs|nvf|nvj|nvb|nv:|nv,|nbq|nbw|nbt|nby|nbp|nba|nbd|nbf|nbg|nbh|nbj|nbk|nbz|nbx|nbc|nbv|nbb|nbn|nb[|nb:|nb;|nb,|nb.|nnt|nnf|nnh|nnj|nnz|nnb|nmt|nml|nmz|nmc|nmv|nmb|nmn|nm:|nm,|nm.|n[d|n[j|n[k|n[b|n]t|n;e|n;b|n,e|n,t|n,s|n,f|n,h|n,j|n,k|n,b|n,.|n.r|n.y|n.u|n.i|n.a|n.f|n.g|n.h|n.k|n.l|n.v|n.b|n.n|n.;|n.,|n..|mwe|mwt|mws|mwf|mwj|mw,|mre|mrt|mry|mrf|mrj|mrk|mrc|mrb|mtq|mty|mtu|mti|mtp|mtd|mtl|mtv|mtn|mt:|mye|myf|myj|myz|myb|mue|muj|mub|mij|mof|mpj|mpz|mdt|mds|mdf|mdj|mdb|md.|mgt|mgf|mgk|mgb|mgn|mhj|mhb|mjy|mjk|mjn|mlt|mls|mlf|mlj|mlc|mlv|mlb|mln|ml,|mzr|mzy|mzd|mzh|mzx|mzv|mz[|mz:|mz,|mz.|mxf|mxb|mcr|mct|mcs|mcf|mcj|mck|mcz|mcb|mcn|mc,|mvt|mvy|mvi|mvs|mvf|mvj|mvz|mvb|mv:|mv,|mv.|mby|mbx|mbv|mb[|mnr|mnt|mnf|mnh|mnj|mnb|mn.|m;f|m<b|m,e|m,t|m,s|m,f|m,h|m,j|m,b|m,.|m.r|m.o|m.p|m.a|m.x|m.c|m.b|m.n|m.:|m.,|m..|[ei|[ek|[el|[en|[e;|[e,|[e.|[rj|[ty|[tj|[tk|[tv|[t,|[t.|[ye|[yt|[ys|[yf|[yj|[yz|[yb|[y.|[uf|[it|[ib|[in|[pd|[df|[dj|[fq|[fe|[ft|[fy|[fd|[fg|[fh|[fj|[fk|[fz|[fx|[fc|[fv|[fb|[fn|[f[|[f;|[f,|[f.|[he|[ht|[hs|[hf|[hj|[hz|[hb|[hm|[h.|[jq|[jr|[jt|[jy|[ju|[jo|[jp|[jd|[jg|[jh|[jj|[jk|[jl|[jx|[jc|[jv|[jn|[j[|[j:|[j;|[j,|[j.|[ke|[kt|[ks|[kf|[kj|[kz|[kb|[k.|[lt|[xb|[cr|[cj|[cz|[cn|[ve|[vt|[vs|[vf|[vb|[v,|[bq|[br|[bt|[by|[bo|[bp|[bd|[bf|[bh|[bk|[bl|[bz|[bx|[bv|[bb|[bn|[b[|[b,|[b.|[ne|[nt|[ns|[nf|[nb|[]t|[,t|[,j|[..|]tr|]ti|]tp|]td|]th|]tk|]tl|]tc|]tv|]t[|]t;|]zy|]zp|]zd|]zh|]zk|]zc|]zn|].y|].n|{el|{tr|{ty|{th|{tk|{ye|{df|{dj|{fq|{fp|{ff|{fh|{fj|{fk|{fc|{he|{ht|{hf|{hb|{jp|{jh|{jk|{jl|{jx|{jn|{j[|{j;|{j,|{j.|{kf|{kj|{vt|{vs|{vv|{v,|{v.|{bh|{bk|{bn|{m.|:er|:ef|:eh|:ty|:tp|:th|:tk|:tc|:yt|:fy|:fh|:fk|:fl|:hb|:jq|:jp|:jv|:le|:lt|:lf|:cr|:vb|:bu|:bp|:bd|:bk|:bl|:bn|:b;|:.k|;we|;wt|;ws|;wf|;eq|;er|;et|;ey|;eo|;ef|;eh|;ek|;ec|;eb|;en|;e:|;e;|;e,|;e.|;re|;rt|;rf|;rj|;rb|;tq|;tw|;tr|;tt|;ty|;tu|;ti|;to|;tp|;ta|;td|;th|;tk|;tl|;tz|;tx|;tc|;tv|;tb|;tn|;t:|;t,|;t.|;ye|;yt|;ys|;yf|;yj|;yz|;yb|;y.|;ue|;uk|;pd|;df|;fq|;fr|;ft|;fy|;fu|;fo|;fp|;fd|;fh|;fk|;fl|;fz|;fc|;fv|;fn|;f[|;f:|;f;|;f,|;f.|;ht|;hf|;hb|;jq|;jr|;jt|;jy|;ju|;jh|;jx|;jv|;j,|;kb|;le|;lt|;ls|;lf|;lj|;lk|;lz|;lb|;lm|;l.|;xt|;xb|;cr|;ve|;vt|;vb|;bq|;bw|;br|;bt|;by|;bu|;bi|;bo|;bp|;bd|;bf|;bg|;bh|;bk|;bl|;bz|;bx|;bc|;bv|;bb|;bn|;b[|;b:|;b;|;b,|;b.|;nj|;mt|;mz|;mb|;m,|;m.|;;t|;;f|;,e|;,t|;,s|;,f|;,j|;,.|;..|<er|<ey|<ei|<ef|<eh|<ej|<ek|<el|<ec|<ev|<e[|<tq|<tr|<ty|<tu|<tp|<th|<tk|<tl|<tc|<tn|<t;|<t,|<sr|<sd|<sk|<sc|<sn|<fq|<fe|<fr|<fy|<fu|<fp|<fd|<fh|<fk|<fl|<fc|<fv|<f[|<f,|<he|<ht|<hs|<hf|<hh|<hj|<hz|<hb|<h.|<jq|<je|<jr|<jt|<jy|<ju|<jh|<jk|<jl|<jz|<jc|<jv|<jb|<j;|<j.|<ke|<kt|<kf|<kj|<kb|<k.|<vd|<br|<by|<bp|<bh|<bj|<bk|<bl|<bc|<bn|<b,|<m.|<.h|>yt|>yj|>uj|>gb|>hr|>ht|>hf|>hv|>hb|>h,|>kt|>kz|>kb|>lb|>xt|>ce|>vj|>v,|>nt|>nk|>[f|>;y|,wt|,ws|,wf|,eq|,er|,et|,ey|,eu|,ei|,ep|,ea|,ed|,ef|,eh|,ek|,el|,ez|,ex|,ec|,ev|,en|,e[|,e:|,e;|,e,|,e.|,re|,rt|,rf|,rj|,rk|,rb|,tq|,tw|,tr|,tt|,ty|,tu|,ti|,to|,tp|,td|,th|,tk|,tl|,tc|,tb|,tn|,t:|,t;|,t,|,t.|,ye|,yt|,yy|,ys|,yf|,yj|,yz|,yb|,y.|,uj|,u.|,ie|,it|,iy|,if|,ik|,ib|,oe|,ot|,of|,ob|,pf|,pj|,ae|,ah|,sq|,sr|,st|,su|,sd|,sk|,sl|,sx|,sc|,sv|,sn|,s[|,s:|,s,|,s.|,dt|,dj|,db|,fq|,fw|,fe|,fr|,ft|,fy|,fu|,fi|,fp|,fd|,fh|,fk|,fl|,fz|,fx|,fc|,fv|,fb|,fn|,f[|,f;|,f,|,f.|,gh|,ht|,hs|,hf|,hj|,hz|,hb|,hm|,h.|,jq|,jr|,jt|,jy|,ju|,ji|,jo|,jp|,jd|,jg|,jh|,jj|,jk|,jl|,jz|,jx|,jc|,jv|,jb|,jn|,j;|,j,|,j.|,ke|,kt|,ks|,kf|,kj|,kz|,kb|,km|,k.|,le|,lf|,lk|,lb|,zo|,zp|,zx|,zc|,zv|,zn|,z:|,z;|,z,|,z.|,xf|,xb|,ce|,cr|,ct|,cj|,ck|,cz|,cx|,cv|,cn|,c,|,ve|,vt|,vf|,vj|,vz|,v.|,bq|,bw|,br|,bt|,by|,bi|,bo|,bp|,ba|,bd|,bh|,bj|,bk|,bl|,bz|,bx|,bc|,bv|,bb|,bn|,b;|,b,|,b.|,nt|,ns|,nz|,mt|,mz|,mc|,mb|,m,|,m.|,[d|,[j|,]t|,]z|,;t|,;f|,;b|,,t|,,h|,,j|,,,|,,.|,.d|,.h|,.k|,.l|,..|.qv|.wr|.wb|.e;|.re|.ry|.rf|.rj|.rc|.rb|.r,|.r.|.tc|.tn|.yw|.ye|.yr|.yt|.yy|.yi|.ys|.yd|.yf|.yj|.yz|.yc|.yb|.ym|.y[|.ue|.ut|.uf|.uj|.u,|.ir|.iy|.ij|.oe|.ot|.of|.oj|.ob|.pe|.pt|.py|.pu|.pf|.pj|.pb|.p,|.af|.az|.dt|.ds|.df|.dj|.fy|.fh|.gr|.gt|.gf|.gg|.gh|.gj|.he|.hr|.ht|.hs|.hf|.hg|.hj|.hb|.hn|.hm|.h,|.kt|.kk|.kb|.km|.k.|.lw|.le|.lr|.lt|.ly|.ls|.ld|.lf|.lj|.lz|.lc|.lv|.lb|.lm|.l;|.l,|.l.|.z.|.xe|.xt|.xy|.xf|.xb|.xn|.x,|.x.|.ct|.cf|.cj|.cz|.cc|.cn|.cm|.c,|.ve|.vr|.vt|.vs|.vf|.vj|.vc|.vv|.vb|.v,|.bk|.bc|.bv|.bn|.ne|.nt|.ny|.ns|.nf|.nh|.nj|.nx|.nc|.nb|.n:|.n,|.n.|.[e|.[t|.[y|.[f|.[j|.[b|.[,|.;t|.;y|.;f|.;b|.<j|.,w|.,e|.,r|.,t|.,y|.,s|.,d|.,f|.,j|.,k|.,z|.,b|.,,|..e|..r|..t|..y|..o|..d|..g|..h|..z|..x|..c|..v|..b|..n|..:|..<|..,|" 
char *notengword=DICTIONARY;

int WhatLang(const char *word)
{
  char wordstr[5];
  int i=0;
  int lw=strlen(word);
  int points=0;
  int tk=0;
  int weight=0;
  char *shr;
  if(lw<1)
    return 0; 
  if(lw==1){
    switch(word[0]) {
      // RU
      case 'e':
      case 'r':
      case 'd':
      case 'f':
      case 'j':
      case 'z':
      case 'c':
      case 'b':
        return 1; // is russian
	break;
      case 'a':
        return -1; // is english
        break;
      default:
        return 0; 
        break;   
    }
  }
  if(lw==2){
    weight = GetWeigthSyllable(word[0], word[1]);
    if (weight > 0){ // is russian
      return 1;
    }
    else if (weight < 0){ // is english
      return -1;
    }
    else
      return 0;
  }
  if(lw==3){
    wordstr[0] = '|';
    wordstr[1] = word[0];
    wordstr[2] = word[1];
    wordstr[3] = word[2];
    wordstr[4] = '|';
    wordstr[5] = '\0';
    shr = strstr(notengword, wordstr);
    if (shr != NULL) {
      return 1;
    }
    else {
      for (i = 0; i <= (lw -1); i++){ 
        weight = weight + GetWeigthSyllable(word[i], word[i+1]);
      }
      if (weight > 0){ // is russian
        return 1;
      }
      else if (weight < 0){ // is english
        return -1;
      }
      else
        return 0;
    }
  }
  if(lw>=4){
    i=0;
    do {      
      wordstr[0] = '|';
      wordstr[1] = word[i];
      wordstr[2] = word[i+1];
      wordstr[3] = word[i+2];
      wordstr[4] = '|';
      wordstr[5] = '\0';
      shr = strstr(notengword, wordstr);
      if (shr != NULL) {
        return 1;
        break;
      }
      i=i+1;
    } while (i <= (lw - 3));
    if (shr == NULL){
      for (i = 0; i <= (lw -1); i++){ 
        weight = weight + GetWeigthSyllable(word[i], word[i+1]);
      }
      if (weight > 0){ // is russian
        return 1;
      }
      else if (weight < 0){ // is english
        return -1;
      }
      else
        return 0;
    }
    return 0;
    
  }
  return 0;
}

// Function Return Weigth Syllable
int GetWeigthSyllable(char word1, char word2){
int i = 0;
int weight  = 0;
switch(word1){
  case 'q':
    switch(word2){
    case 'r':
      weight += __QR;
      break;
    case 'y':
      weight += __QY;
      break;
    case 'u':
      weight += __QU;
      break;
    case 'i':
      weight += __QI;
      break;
    case 'l':
      weight += __QL;
      break;
    case 'x':
      weight += __QX;
      break;
    case 'c':
      weight += __QC;
      break;
    case 'v':
      weight += __QV;
      break;
    case 'n':
      weight += __QN;
      break;
    case ',':
      weight += __Qzp;
      break;
    case '.':
      weight += __Qtch;
      break;
    }
  break;
  case 'w':
    switch(word2){
    case 'e':
      weight += __WE;
      break;
    case 't':
      weight += __WT;
      break;
    case 'i':
      weight += __WI;
      break;
    case 'o':
      weight += __WO;
      break;
    case 'a':
      weight += __WA;
      break;
    case 'f':
      weight += __WF;
      break;
    case 'h':
      weight += __WH;
      break;
    case 'j':
      weight += __WJ;
      break;
    case 'l':
      weight += __WL;
      break;
    case 'b':
      weight += __WB;
      break;
    case 'n':
      weight += __WN;
      break;
    case ',':
      weight += __Wzp;
      break;
    case '.':
      weight += __Wtch;
      break;
    }
  break;
  case 'e':
    switch(word2){
    case 'q':
      weight += __EQ;
      break;
    case 'w':
      weight += __EW;
      break;
    case 'e':
      weight += __EE;
      break;
    case 'r':
      weight += __ER;
      break;
    case 't':
      weight += __ET;
      break;
    case 'y':
      weight += __EY;
      break;
    case 'u':
      weight += __EU;
      break;
    case 'i':
      weight += __EI;
      break;
    case 'p':
      weight += __EP;
      break;
    case 'a':
      weight += __EA;
      break;
    case 's':
      weight += __ES;
      break;
    case 'd':
      weight += __ED;
      break;
    case 'f':
      weight += __EF;
      break;
    case 'g':
      weight += __EG;
      break;
    case 'h':
      weight += __EH;
      break;
    case 'k':
      weight += __EK;
      break;
    case 'l':
      weight += __EL;
      break;
    case 'z':
      weight += __EZ;
      break;
    case 'x':
      weight += __EX;
      break;
    case 'c':
      weight += __EC;
      break;
    case 'v':
      weight += __EV;
      break;
    case 'n':
      weight += __EN;
      break;
    case 'm':
      weight += __EM;
      break;
    case '[':
      weight += __Eksl;
      break;
    case ';':
      weight += __Etz;
      break;
    case ',':
      weight += __Ezp;
      break;
    case '.':
      weight += __Etch;
      break;
    }
  break;
  case 'r':
    switch(word2){
    case 'e':
      weight += __RE;
      break;
    case 'r':
      weight += __RR;
      break;
    case 't':
      weight += __RT;
      break;
    case 'y':
      weight += __RY;
      break;
    case 'u':
      weight += __RU;
      break;
    case 'i':
      weight += __RI;
      break;
    case 'o':
      weight += __RO;
      break;
    case 'p':
      weight += __RP;
      break;
    case 'a':
      weight += __RA;
      break;
    case 's':
      weight += __RS;
      break;
    case 'd':
      weight += __RD;
      break;
    case 'f':
      weight += __RF;
      break;
    case 'g':
      weight += __RG;
      break;
    case 'h':
      weight += __RH;
      break;
    case 'j':
      weight += __RJ;
      break;
    case 'l':
      weight += __RL;
      break;
    case 'c':
      weight += __RC;
      break;
    case 'v':
      weight += __RV;
      break;
    case 'b':
      weight += __RB;
      break;
    case 'n':
      weight += __RN;
      break;
    case 'm':
      weight += __RM;
      break;
    case ';':
      weight += __Rtz;
      break;
    case ',':
      weight += __Rzp;
      break;
    case '.':
      weight += __Rtch;
      break;
    }
  break;
  case 't':
    switch(word2){
    case 'q':
      weight += __TQ;
      break;
    case 'w':
      weight += __TW;
      break;
    case 'e':
      weight += __TE;
      break;
    case 'r':
      weight += __TR;
      break;
    case 't':
      weight += __TT;
      break;
    case 'y':
      weight += __TY;
      break;
    case 'u':
      weight += __TU;
      break;
    case 'i':
      weight += __TI;
      break;
    case 'o':
      weight += __TO;
      break;
    case 'p':
      weight += __TP;
      break;
    case 'a':
      weight += __TA;
      break;
    case 's':
      weight += __TS;
      break;
    case 'd':
      weight += __TD;
      break;
    case 'g':
      weight += __TG;
      break;
    case 'h':
      weight += __TH;
      break;
    case 'j':
      weight += __TJ;
      break;
    case 'k':
      weight += __TK;
      break;
    case 'l':
      weight += __TL;
      break;
    case 'z':
      weight += __TZ;
      break;
    case 'x':
      weight += __TX;
      break;
    case 'c':
      weight += __TC;
      break;
    case 'v':
      weight += __TV;
      break;
    case 'b':
      weight += __TB;
      break;
    case 'n':
      weight += __TN;
      break;
    case 'm':
      weight += __TM;
      break;
    case '[':
      weight += __Tksl;
      break;
    case ';':
      weight += __Ttz;
      break;
    case ',':
      weight += __Tzp;
      break;
    case '.':
      weight += __Ttch;
      break;
    }
  break;
  case 'y':
    switch(word2){
    case 'w':
      weight += __YW;
      break;
    case 'e':
      weight += __YE;
      break;
    case 'r':
      weight += __YR;
      break;
    case 't':
      weight += __YT;
      break;
    case 'y':
      weight += __YY;
      break;
    case 'u':
      weight += __YU;
      break;
    case 'i':
      weight += __YI;
      break;
    case 'o':
      weight += __YO;
      break;
    case 's':
      weight += __YS;
      break;
    case 'd':
      weight += __YD;
      break;
    case 'f':
      weight += __YF;
      break;
    case 'h':
      weight += __YH;
      break;
    case 'j':
      weight += __YJ;
      break;
    case 'l':
      weight += __YL;
      break;
    case 'z':
      weight += __YZ;
      break;
    case 'x':
      weight += __YX;
      break;
    case 'c':
      weight += __YC;
      break;
    case 'b':
      weight += __YB;
      break;
    case 'n':
      weight += __YN;
      break;
    case 'm':
      weight += __YM;
      break;
    case ';':
      weight += __Ytz;
      break;
    case ',':
      weight += __Yzp;
      break;
    case '.':
      weight += __Ytch;
      break;
    }
  break;
  case 'u':
    switch(word2){
    case 'e':
      weight += __UE;
      break;
    case 'r':
      weight += __UR;
      break;
    case 't':
      weight += __UT;
      break;
    case 'y':
      weight += __UY;
      break;
    case 'i':
      weight += __UI;
      break;
    case 'p':
      weight += __UP;
      break;
    case 'a':
      weight += __UA;
      break;
    case 's':
      weight += __US;
      break;
    case 'd':
      weight += __UD;
      break;
    case 'f':
      weight += __UF;
      break;
    case 'g':
      weight += __UG;
      break;
    case 'h':
      weight += __UH;
      break;
    case 'j':
      weight += __UJ;
      break;
    case 'k':
      weight += __UK;
      break;
    case 'l':
      weight += __UL;
      break;
    case 'c':
      weight += __UC;
      break;
    case 'b':
      weight += __UB;
      break;
    case 'n':
      weight += __UN;
      break;
    case 'm':
      weight += __UM;
      break;
    }
  break;
  case 'i':
    switch(word2){
    case 'e':
      weight += __IE;
      break;
    case 'r':
      weight += __IR;
      break;
    case 't':
      weight += __IT;
      break;
    case 'y':
      weight += __IY;
      break;
    case 'o':
      weight += __IO;
      break;
    case 'p':
      weight += __IP;
      break;
    case 'a':
      weight += __IA;
      break;
    case 's':
      weight += __IS;
      break;
    case 'd':
      weight += __ID;
      break;
    case 'f':
      weight += __IF;
      break;
    case 'g':
      weight += __IG;
      break;
    case 'j':
      weight += __IJ;
      break;
    case 'l':
      weight += __IL;
      break;
    case 'z':
      weight += __IZ;
      break;
    case 'x':
      weight += __IX;
      break;
    case 'c':
      weight += __IC;
      break;
    case 'v':
      weight += __IV;
      break;
    case 'b':
      weight += __IB;
      break;
    case 'n':
      weight += __IN;
      break;
    case 'm':
      weight += __IM;
      break;
    }
  break;
  case 'o':
    switch(word2){
    case 'w':
      weight += __OW;
      break;
    case 'e':
      weight += __OE;
      break;
    case 'r':
      weight += __OR;
      break;
    case 't':
      weight += __OT;
      break;
    case 'y':
      weight += __OY;
      break;
    case 'u':
      weight += __OU;
      break;
    case 'i':
      weight += __OI;
      break;
    case 'o':
      weight += __OO;
      break;
    case 'p':
      weight += __OP;
      break;
    case 'a':
      weight += __OA;
      break;
    case 's':
      weight += __OS;
      break;
    case 'd':
      weight += __OD;
      break;
    case 'f':
      weight += __OF;
      break;
    case 'g':
      weight += __OG;
      break;
    case 'h':
      weight += __OH;
      break;
    case 'k':
      weight += __OK;
      break;
    case 'l':
      weight += __OL;
      break;
    case 'c':
      weight += __OC;
      break;
    case 'v':
      weight += __OV;
      break;
    case 'b':
      weight += __OB;
      break;
    case 'n':
      weight += __ON;
      break;
    case 'm':
      weight += __OM;
      break;
    case ',':
      weight += __Ozp;
      break;
    case '.':
      weight += __Otch;
      break;
    }
  break;
  case 'p':
    switch(word2){
    case 'e':
      weight += __PE;
      break;
    case 'r':
      weight += __PR;
      break;
    case 't':
      weight += __PT;
      break;
    case 'y':
      weight += __PY;
      break;
    case 'i':
      weight += __PI;
      break;
    case 'o':
      weight += __PO;
      break;
    case 'p':
      weight += __PP;
      break;
    case 'a':
      weight += __PA;
      break;
    case 'd':
      weight += __PD;
      break;
    case 'f':
      weight += __PF;
      break;
    case 'h':
      weight += __PH;
      break;
    case 'j':
      weight += __PJ;
      break;
    case 'k':
      weight += __PK;
      break;
    case 'l':
      weight += __PL;
      break;
    case 'z':
      weight += __PZ;
      break;
    case 'v':
      weight += __PV;
      break;
    case 'b':
      weight += __PB;
      break;
    case 'm':
      weight += __PM;
      break;
    case ';':
      weight += __Ptz;
      break;
    case ',':
      weight += __Pzp;
      break;
    case '.':
      weight += __Ptch;
      break;
    }
  break;
  case 'a':
    switch(word2){
    case 'w':
      weight += __AW;
      break;
    case 'e':
      weight += __AE;
      break;
    case 'r':
      weight += __AR;
      break;
    case 't':
      weight += __AT;
      break;
    case 'y':
      weight += __AY;
      break;
    case 'u':
      weight += __AU;
      break;
    case 'i':
      weight += __AI;
      break;
    case 'p':
      weight += __AP;
      break;
    case 's':
      weight += __AS;
      break;
    case 'd':
      weight += __AD;
      break;
    case 'f':
      weight += __AF;
      break;
    case 'g':
      weight += __AG;
      break;
    case 'j':
      weight += __AJ;
      break;
    case 'k':
      weight += __AK;
      break;
    case 'l':
      weight += __AL;
      break;
    case 'z':
      weight += __AZ;
      break;
    case 'c':
      weight += __AC;
      break;
    case 'v':
      weight += __AV;
      break;
    case 'b':
      weight += __AB;
      break;
    case 'n':
      weight += __AN;
      break;
    case 'm':
      weight += __AM;
      break;
    case ',':
      weight += __Azp;
      break;
    case '.':
      weight += __Atch;
      break;
    }
  break;
  case 's':
    switch(word2){
    case 'q':
      weight += __SQ;
      break;
    case 'w':
      weight += __SW;
      break;
    case 'e':
      weight += __SE;
      break;
    case 'r':
      weight += __SR;
      break;
    case 't':
      weight += __ST;
      break;
    case 'u':
      weight += __SU;
      break;
    case 'i':
      weight += __SI;
      break;
    case 'o':
      weight += __SO;
      break;
    case 'p':
      weight += __SP;
      break;
    case 'a':
      weight += __SA;
      break;
    case 's':
      weight += __SS;
      break;
    case 'd':
      weight += __SD;
      break;
    case 'f':
      weight += __SF;
      break;
    case 'g':
      weight += __SG;
      break;
    case 'h':
      weight += __SH;
      break;
    case 'k':
      weight += __SK;
      break;
    case 'l':
      weight += __SL;
      break;
    case 'x':
      weight += __SX;
      break;
    case 'c':
      weight += __SC;
      break;
    case 'v':
      weight += __SV;
      break;
    case 'n':
      weight += __SN;
      break;
    case 'm':
      weight += __SM;
      break;
    case '[':
      weight += __Sksl;
      break;
    case ':':
      weight += __Sdt;
      break;
    case ',':
      weight += __Szp;
      break;
    case '.':
      weight += __Stch;
      break;
    }
  break;
  case 'd':
    switch(word2){
    case 'e':
      weight += __DE;
      break;
    case 'r':
      weight += __DR;
      break;
    case 't':
      weight += __DT;
      break;
    case 'y':
      weight += __DY;
      break;
    case 'u':
      weight += __DU;
      break;
    case 'i':
      weight += __DI;
      break;
    case 'o':
      weight += __DO;
      break;
    case 'p':
      weight += __DP;
      break;
    case 'a':
      weight += __DA;
      break;
    case 's':
      weight += __DS;
      break;
    case 'd':
      weight += __DD;
      break;
    case 'f':
      weight += __DF;
      break;
    case 'g':
      weight += __DG;
      break;
    case 'h':
      weight += __DH;
      break;
    case 'j':
      weight += __DJ;
      break;
    case 'k':
      weight += __DK;
      break;
    case 'z':
      weight += __DZ;
      break;
    case 'x':
      weight += __DX;
      break;
    case 'c':
      weight += __DC;
      break;
    case 'b':
      weight += __DB;
      break;
    case 'n':
      weight += __DN;
      break;
    case ':':
      weight += __Ddt;
      break;
    case ';':
      weight += __Dtz;
      break;
    case ',':
      weight += __Dzp;
      break;
    case '.':
      weight += __Dtch;
      break;
    }
  break;
  case 'f':
    switch(word2){
    case 'q':
      weight += __FQ;
      break;
    case 'w':
      weight += __FW;
      break;
    case 'e':
      weight += __FE;
      break;
    case 'r':
      weight += __FR;
      break;
    case 't':
      weight += __FT;
      break;
    case 'y':
      weight += __FY;
      break;
    case 'u':
      weight += __FU;
      break;
    case 'i':
      weight += __FI;
      break;
    case 'o':
      weight += __FO;
      break;
    case 'p':
      weight += __FP;
      break;
    case 'a':
      weight += __FA;
      break;
    case 'd':
      weight += __FD;
      break;
    case 'f':
      weight += __FF;
      break;
    case 'g':
      weight += __FG;
      break;
    case 'h':
      weight += __FH;
      break;
    case 'k':
      weight += __FK;
      break;
    case 'l':
      weight += __FL;
      break;
    case 'z':
      weight += __FZ;
      break;
    case 'x':
      weight += __FX;
      break;
    case 'c':
      weight += __FC;
      break;
    case 'v':
      weight += __FV;
      break;
    case 'b':
      weight += __FB;
      break;
    case 'n':
      weight += __FN;
      break;
    case '[':
      weight += __Fksl;
      break;
    case ':':
      weight += __Fdt;
      break;
    case ';':
      weight += __Ftz;
      break;
    case ',':
      weight += __Fzp;
      break;
    case '.':
      weight += __Ftch;
      break;
    }
  break;
  case 'g':
    switch(word2){
    case 'e':
      weight += __GE;
      break;
    case 'r':
      weight += __GR;
      break;
    case 't':
      weight += __GT;
      break;
    case 'y':
      weight += __GY;
      break;
    case 'u':
      weight += __GU;
      break;
    case 'i':
      weight += __GI;
      break;
    case 'o':
      weight += __GO;
      break;
    case 'a':
      weight += __GA;
      break;
    case 's':
      weight += __GS;
      break;
    case 'f':
      weight += __GF;
      break;
    case 'g':
      weight += __GG;
      break;
    case 'h':
      weight += __GH;
      break;
    case 'j':
      weight += __GJ;
      break;
    case 'k':
      weight += __GK;
      break;
    case 'l':
      weight += __GL;
      break;
    case 'z':
      weight += __GZ;
      break;
    case 'c':
      weight += __GC;
      break;
    case 'b':
      weight += __GB;
      break;
    case 'n':
      weight += __GN;
      break;
    case 'm':
      weight += __GM;
      break;
    case ':':
      weight += __Gdt;
      break;
    case ',':
      weight += __Gzp;
      break;
    case '.':
      weight += __Gtch;
      break;
    }
  break;
  case 'h':
    switch(word2){
    case 'e':
      weight += __HE;
      break;
    case 'r':
      weight += __HR;
      break;
    case 't':
      weight += __HT;
      break;
    case 'y':
      weight += __HY;
      break;
    case 'u':
      weight += __HU;
      break;
    case 'i':
      weight += __HI;
      break;
    case 'o':
      weight += __HO;
      break;
    case 'a':
      weight += __HA;
      break;
    case 's':
      weight += __HS;
      break;
    case 'd':
      weight += __HD;
      break;
    case 'f':
      weight += __HF;
      break;
    case 'g':
      weight += __HG;
      break;
    case 'h':
      weight += __HH;
      break;
    case 'j':
      weight += __HJ;
      break;
    case 'k':
      weight += __HK;
      break;
    case 'l':
      weight += __HL;
      break;
    case 'z':
      weight += __HZ;
      break;
    case 'x':
      weight += __HX;
      break;
    case 'c':
      weight += __HC;
      break;
    case 'v':
      weight += __HV;
      break;
    case 'b':
      weight += __HB;
      break;
    case 'n':
      weight += __HN;
      break;
    case 'm':
      weight += __HM;
      break;
    case '[':
      weight += __Hksl;
      break;
    case ';':
      weight += __Htz;
      break;
    case ',':
      weight += __Hzp;
      break;
    case '.':
      weight += __Htch;
      break;
    }
  break;
  case 'j':
    switch(word2){
    case 'q':
      weight += __JQ;
      break;
    case 'w':
      weight += __JW;
      break;
    case 'e':
      weight += __JE;
      break;
    case 'r':
      weight += __JR;
      break;
    case 't':
      weight += __JT;
      break;
    case 'y':
      weight += __JY;
      break;
    case 'u':
      weight += __JU;
      break;
    case 'i':
      weight += __JI;
      break;
    case 'o':
      weight += __JO;
      break;
    case 'p':
      weight += __JP;
      break;
    case 'a':
      weight += __JA;
      break;
    case 'd':
      weight += __JD;
      break;
    case 'g':
      weight += __JG;
      break;
    case 'h':
      weight += __JH;
      break;
    case 'j':
      weight += __JJ;
      break;
    case 'k':
      weight += __JK;
      break;
    case 'l':
      weight += __JL;
      break;
    case 'z':
      weight += __JZ;
      break;
    case 'x':
      weight += __JX;
      break;
    case 'c':
      weight += __JC;
      break;
    case 'v':
      weight += __JV;
      break;
    case 'b':
      weight += __JB;
      break;
    case 'n':
      weight += __JN;
      break;
    case '[':
      weight += __Jksl;
      break;
    case ':':
      weight += __Jdt;
      break;
    case ';':
      weight += __Jtz;
      break;
    case ',':
      weight += __Jzp;
      break;
    case '.':
      weight += __Jtch;
      break;
    }
  break;
  case 'k':
    switch(word2){
    case 'e':
      weight += __KE;
      break;
    case 'r':
      weight += __KR;
      break;
    case 't':
      weight += __KT;
      break;
    case 'y':
      weight += __KY;
      break;
    case 'u':
      weight += __KU;
      break;
    case 'i':
      weight += __KI;
      break;
    case 'o':
      weight += __KO;
      break;
    case 'a':
      weight += __KA;
      break;
    case 's':
      weight += __KS;
      break;
    case 'f':
      weight += __KF;
      break;
    case 'h':
      weight += __KH;
      break;
    case 'j':
      weight += __KJ;
      break;
    case 'k':
      weight += __KK;
      break;
    case 'z':
      weight += __KZ;
      break;
    case 'x':
      weight += __KX;
      break;
    case 'c':
      weight += __KC;
      break;
    case 'b':
      weight += __KB;
      break;
    case 'n':
      weight += __KN;
      break;
    case 'm':
      weight += __KM;
      break;
    case ':':
      weight += __Kdt;
      break;
    case ';':
      weight += __Ktz;
      break;
    case ',':
      weight += __Kzp;
      break;
    case '.':
      weight += __Ktch;
      break;
    }
  break;
  case 'l':
    switch(word2){
    case 'w':
      weight += __LW;
      break;
    case 'e':
      weight += __LE;
      break;
    case 'r':
      weight += __LR;
      break;
    case 't':
      weight += __LT;
      break;
    case 'y':
      weight += __LY;
      break;
    case 'u':
      weight += __LU;
      break;
    case 'i':
      weight += __LI;
      break;
    case 'o':
      weight += __LO;
      break;
    case 'p':
      weight += __LP;
      break;
    case 'a':
      weight += __LA;
      break;
    case 's':
      weight += __LS;
      break;
    case 'd':
      weight += __LD;
      break;
    case 'f':
      weight += __LF;
      break;
    case 'g':
      weight += __LG;
      break;
    case 'h':
      weight += __LH;
      break;
    case 'j':
      weight += __LJ;
      break;
    case 'k':
      weight += __LK;
      break;
    case 'l':
      weight += __LL;
      break;
    case 'z':
      weight += __LZ;
      break;
    case 'c':
      weight += __LC;
      break;
    case 'v':
      weight += __LV;
      break;
    case 'b':
      weight += __LB;
      break;
    case 'n':
      weight += __LN;
      break;
    case 'm':
      weight += __LM;
      break;
    case ';':
      weight += __Ltz;
      break;
    case ',':
      weight += __Lzp;
      break;
    case '.':
      weight += __Ltch;
      break;
    }
  break;
  case 'z':
    switch(word2){
    case 'e':
      weight += __ZE;
      break;
    case 'r':
      weight += __ZR;
      break;
    case 't':
      weight += __ZT;
      break;
    case 'y':
      weight += __ZY;
      break;
    case 'u':
      weight += __ZU;
      break;
    case 'o':
      weight += __ZO;
      break;
    case 'p':
      weight += __ZP;
      break;
    case 'a':
      weight += __ZA;
      break;
    case 'd':
      weight += __ZD;
      break;
    case 'h':
      weight += __ZH;
      break;
    case 'k':
      weight += __ZK;
      break;
    case 'l':
      weight += __ZL;
      break;
    case 'x':
      weight += __ZX;
      break;
    case 'c':
      weight += __ZC;
      break;
    case 'v':
      weight += __ZV;
      break;
    case 'n':
      weight += __ZN;
      break;
    case '[':
      weight += __Zksl;
      break;
    case ':':
      weight += __Zdt;
      break;
    case ';':
      weight += __Ztz;
      break;
    case ',':
      weight += __Zzp;
      break;
    case '.':
      weight += __Ztch;
      break;
    }
  break;
  case 'x':
    switch(word2){
    case 'e':
      weight += __XE;
      break;
    case 'r':
      weight += __XR;
      break;
    case 't':
      weight += __XT;
      break;
    case 'y':
      weight += __XY;
      break;
    case 'p':
      weight += __XP;
      break;
    case 'a':
      weight += __XA;
      break;
    case 'f':
      weight += __XF;
      break;
    case 'j':
      weight += __XJ;
      break;
    case 'c':
      weight += __XC;
      break;
    case 'b':
      weight += __XB;
      break;
    case 'n':
      weight += __XN;
      break;
    case 'm':
      weight += __XM;
      break;
    }
  break;
  case 'c':
    switch(word2){
    case 'q':
      weight += __CQ;
      break;
    case 'e':
      weight += __CE;
      break;
    case 'r':
      weight += __CR;
      break;
    case 't':
      weight += __CT;
      break;
    case 'y':
      weight += __CY;
      break;
    case 'u':
      weight += __CU;
      break;
    case 'i':
      weight += __CI;
      break;
    case 'o':
      weight += __CO;
      break;
    case 'a':
      weight += __CA;
      break;
    case 's':
      weight += __CS;
      break;
    case 'd':
      weight += __CD;
      break;
    case 'f':
      weight += __CF;
      break;
    case 'g':
      weight += __CG;
      break;
    case 'h':
      weight += __CH;
      break;
    case 'j':
      weight += __CJ;
      break;
    case 'k':
      weight += __CK;
      break;
    case 'l':
      weight += __CL;
      break;
    case 'z':
      weight += __CZ;
      break;
    case 'x':
      weight += __CX;
      break;
    case 'c':
      weight += __CC;
      break;
    case 'v':
      weight += __CV;
      break;
    case 'b':
      weight += __CB;
      break;
    case 'n':
      weight += __CN;
      break;
    case 'm':
      weight += __CM;
      break;
    case '[':
      weight += __Cksl;
      break;
    case ',':
      weight += __Czp;
      break;
    case '.':
      weight += __Ctch;
      break;
    }
  break;
  case 'v':
    switch(word2){
    case 'e':
      weight += __VE;
      break;
    case 'r':
      weight += __VR;
      break;
    case 't':
      weight += __VT;
      break;
    case 'y':
      weight += __VY;
      break;
    case 'i':
      weight += __VI;
      break;
    case 'o':
      weight += __VO;
      break;
    case 'a':
      weight += __VA;
      break;
    case 's':
      weight += __VS;
      break;
    case 'f':
      weight += __VF;
      break;
    case 'g':
      weight += __VG;
      break;
    case 'h':
      weight += __VH;
      break;
    case 'j':
      weight += __VJ;
      break;
    case 'k':
      weight += __VK;
      break;
    case 'z':
      weight += __VZ;
      break;
    case 'c':
      weight += __VC;
      break;
    case 'v':
      weight += __VV;
      break;
    case 'b':
      weight += __VB;
      break;
    case 'm':
      weight += __VM;
      break;
    case ',':
      weight += __Vzp;
      break;
    case '.':
      weight += __Vtch;
      break;
    }
  break;
  case 'b':
    switch(word2){
    case 'q':
      weight += __BQ;
      break;
    case 'w':
      weight += __BW;
      break;
    case 'e':
      weight += __BE;
      break;
    case 'r':
      weight += __BR;
      break;
    case 't':
      weight += __BT;
      break;
    case 'y':
      weight += __BY;
      break;
    case 'u':
      weight += __BU;
      break;
    case 'i':
      weight += __BI;
      break;
    case 'o':
      weight += __BO;
      break;
    case 'p':
      weight += __BP;
      break;
    case 'a':
      weight += __BA;
      break;
    case 's':
      weight += __BS;
      break;
    case 'd':
      weight += __BD;
      break;
    case 'f':
      weight += __BF;
      break;
    case 'g':
      weight += __BG;
      break;
    case 'h':
      weight += __BH;
      break;
    case 'j':
      weight += __BJ;
      break;
    case 'k':
      weight += __BK;
      break;
    case 'l':
      weight += __BL;
      break;
    case 'z':
      weight += __BZ;
      break;
    case 'x':
      weight += __BX;
      break;
    case 'c':
      weight += __BC;
      break;
    case 'v':
      weight += __BV;
      break;
    case 'b':
      weight += __BB;
      break;
    case 'n':
      weight += __BN;
      break;
    case '[':
      weight += __Bksl;
      break;
    case ':':
      weight += __Bdt;
      break;
    case ';':
      weight += __Btz;
      break;
    case ',':
      weight += __Bzp;
      break;
    case '.':
      weight += __Btch;
      break;
    }
  break;
  case 'n':
    switch(word2){
    case 'e':
      weight += __NE;
      break;
    case 'r':
      weight += __NR;
      break;
    case 'y':
      weight += __NY;
      break;
    case 'u':
      weight += __NU;
      break;
    case 'i':
      weight += __NI;
      break;
    case 'o':
      weight += __NO;
      break;
    case 'a':
      weight += __NA;
      break;
    case 's':
      weight += __NS;
      break;
    case 'd':
      weight += __ND;
      break;
    case 'f':
      weight += __NF;
      break;
    case 'g':
      weight += __NG;
      break;
    case 'h':
      weight += __NH;
      break;
    case 'j':
      weight += __NJ;
      break;
    case 'k':
      weight += __NK;
      break;
    case 'l':
      weight += __NL;
      break;
    case 'z':
      weight += __NZ;
      break;
    case 'x':
      weight += __NX;
      break;
    case 'c':
      weight += __NC;
      break;
    case 'v':
      weight += __NV;
      break;
    case 'b':
      weight += __NB;
      break;
    case 'n':
      weight += __NN;
      break;
    case 'm':
      weight += __NM;
      break;
    case ':':
      weight += __Ndt;
      break;
    case ';':
      weight += __Ntz;
      break;
    case ',':
      weight += __Nzp;
      break;
    case '.':
      weight += __Ntch;
      break;
    }
  break;
  case 'm':
    switch(word2){
    case 'w':
      weight += __MW;
      break;
    case 'e':
      weight += __ME;
      break;
    case 'r':
      weight += __MR;
      break;
    case 't':
      weight += __MT;
      break;
    case 'y':
      weight += __MY;
      break;
    case 'u':
      weight += __MU;
      break;
    case 'i':
      weight += __MI;
      break;
    case 'o':
      weight += __MO;
      break;
    case 'p':
      weight += __MP;
      break;
    case 'a':
      weight += __MA;
      break;
    case 's':
      weight += __MS;
      break;
    case 'l':
      weight += __ML;
      break;
    case 'z':
      weight += __MZ;
      break;
    case 'x':
      weight += __MX;
      break;
    case 'c':
      weight += __MC;
      break;
    case 'v':
      weight += __MV;
      break;
    case 'b':
      weight += __MB;
      break;
    case 'm':
      weight += __MM;
      break;
    case ':':
      weight += __Mdt;
      break;
    case ',':
      weight += __Mzp;
      break;
    case '.':
      weight += __Mtch;
      break;
    }
  break;
  case '[':
    switch(word2){
    case 'e':
      weight += __kslE;
      break;
    case 'y':
      weight += __kslY;
      break;
    case 'd':
      weight += __kslD;
      break;
    case 'f':
      weight += __kslF;
      break;
    case 'h':
      weight += __kslH;
      break;
    case 'j':
      weight += __kslJ;
      break;
    case 'k':
      weight += __kslK;
      break;
    case 'b':
      weight += __kslB;
      break;
    case ',':
      weight += __kslzp;
      break;
    case '.':
      weight += __ksltch;
      break;
    }
  break;
  case ']':
    switch(word2){
    case 't':
      weight += __kspT;
      break;
    case 'z':
      weight += __kspZ;
      break;
    }
  break;
  case '{':
    switch(word2){
    case 'j':
      weight += __fslJ;
      break;
    }
  break;
  case ';':
    switch(word2){
    case 'e':
      weight += __tzE;
      break;
    case 'r':
      weight += __tzR;
      break;
    case 't':
      weight += __tzT;
      break;
    case 'y':
      weight += __tzY;
      break;
    case 'f':
      weight += __tzF;
      break;
    case 'j':
      weight += __tzJ;
      break;
    case 'l':
      weight += __tzL;
      break;
    case 'b':
      weight += __tzB;
      break;
    case ',':
      weight += __tzzp;
      break;
    }
  break;
  case '<':
    switch(word2){
    case 'e':
      weight += __tslE;
      break;
    case 't':
      weight += __tslT;
      break;
    case 'h':
      weight += __tslH;
      break;
    case 'j':
      weight += __tslJ;
      break;
    case 'b':
      weight += __tslB;
      break;
    }
  break;
  case ',':
    switch(word2){
    case 'e':
      weight += __zpE;
      break;
    case 'r':
      weight += __zpR;
      break;
    case 't':
      weight += __zpT;
      break;
    case 'y':
      weight += __zpY;
      break;
    case 'o':
      weight += __zpO;
      break;
    case 's':
      weight += __zpS;
      break;
    case 'd':
      weight += __zpD;
      break;
    case 'f':
      weight += __zpF;
      break;
    case 'h':
      weight += __zpH;
      break;
    case 'j':
      weight += __zpJ;
      break;
    case 'k':
      weight += __zpK;
      break;
    case 'z':
      weight += __zpZ;
      break;
    case 'c':
      weight += __zpC;
      break;
    case 'b':
      weight += __zpB;
      break;
    case ']':
      weight += __zpksp;
      break;
    case ',':
      weight += __zpzp;
      break;
    case '.':
      weight += __zptch;
      break;
    }
  break;
  case '.':
    switch(word2){
    case 'o':
      weight += __tchO;
      break;
    case 'l':
      weight += __tchL;
      break;
    case 'x':
      weight += __tchX;
      break;
    case 'c':
      weight += __tchC;
      break;
    case 'n':
      weight += __tchN;
      break;
    case ',':
      weight += __tchzp;
      break;
    case '.':
      weight += __tchtch;
      break;
    }
  break;
}
return weight;
}
