/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Originally wriyyen by Art Vodolazky <burivuh@crew.org.ru>,
 * after it I (Alphex Kaänoken <kaanoken@crew.org.ru>) re-wrote it.
 * after Andrew Crew Kuznetsov <andrew.crew.kuznetsov@gmail.com> rewrite it.
 *
 * (c) Crew IT Research Labs 2004
 */

#include "client_manager.h"
#include <string.h>
#include <stdlib.h>

/*TODO: 
 * - rewrite it to one strucure (it's global)
 * - make-up own ConvPoint for every client
 */

status xClientManager_getClientInfo (xevent * event, xifocus * ifocus)
{
  status err=SUCCESS;

  err=ifocus->update(ifocus);
  /*ERROR if None*/
  if(ERROR==err) {
    send_error(DEBUG,"Update xifocus failed!\n",NULL);
    return err;
  }	  
  if (!ifocus->has_chng(ifocus))
    return WARNING;
  err=event->set_communicator(event,ifocus->owner);
  return err;
}

bool xClientManager_testAppName (xifocus * ifocus, app_list * sup_apps_list)
{
  app_list * al_dbg;
  al_dbg = sup_apps_list;
  num have_name = 0;
  char *app_name = NULL;	
	
  app_name = ifocus->owner->get_wmclass_name(ifocus->owner);
  if (app_name == NULL) {
    return FALSE;	/*may be client is dead?*/
  }

  while (sup_apps_list != NULL) {  
    if (!strncmp
          ((char *) sup_apps_list->name, (char *) app_name,
            strlen ((char *) sup_apps_list->name)))
      ++have_name;
      sup_apps_list = sup_apps_list->next;
  }
 
  if (have_name < 1) {
    /*if (ifocus->has_chng(ifocus)) {
      send_error (DEBUG, "Application '%s' not in list:\n", &app_name); 
      while (al_dbg != NULL) {
        send_error (DEBUG, "  '%s'\n", &al_dbg->name);
        al_dbg = al_dbg->next;
      }
    }  */
	free (app_name);  
    return FALSE;
  }
  free (app_name);
  return TRUE;
}

status xClientManager_beginToListenClient (xifocus * ifocus)
{
  status err;
  num iterator;
  
  err = ifocus->owner->set_event_mask(ifocus->owner, CLIENT_EVENT_MASK);
  if (err == ERROR)
    return err;
  else{
    for(iterator = 0; iterator < ifocus->ptr_num; iterator++)
      err = ifocus->owner->set_event_mask(ifocus->ptr[iterator], CLIENT_EVENT_MASK);
  }
  return err;
}
