/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Art Vodolazsky <burivuh@crew.org.ru>
 *  a lot of modifications by Alphex Kaänoken <kaanoken@crew.org.ru>
 *
 *
 *  (c) Crew IT Research Labs 2004
 */

#ifndef _PROGRAM_H_
#define _PROGRAM_H_

#include "../libmisc/types.h"
#include "../libmisc/error.h"
#include "select_manager.h"
#include "key_log_manager.h"
#include "client_manager.h"
#include "../libmisc/xconfig.h"

#define TIME_TO_WAIT_SEL_OWNER 1000

typedef struct _xprograminfo
{
  xobj *xobject;
  xstr *xword;
  xstr *xstring;
  xswitchlang *xswitchlng;
  xselection *selection;
  xevent *xevnt;
  xifocus *ifocus;
  xkeylogbuffer *xklbuffer;
  xbindingtable *xbtable;

  int (*uninit)(struct _xprograminfo *p); 
  bool (*update)(struct _xprograminfo *p, app_list * sup_apps_list);
  num (*process_input)(struct _xprograminfo *p);
  bool (*perform_current_bind)(struct _xprograminfo *p, xconf* xnc);
  int (*perform_current_mode)(struct _xprograminfo *p, xconf * xnc);
  int (*chng_word_by_selection) (struct _xprograminfo *p, status lang);
  int (*chng_string_by_selection) (struct _xprograminfo *p, status lang);
  int (*set_convert_text)(struct _xprograminfo *p, unsigned char *text);	  
  int (*get_curr_lang)(struct _xprograminfo *p);
} xprograminfo;

xprograminfo *xprogram_init (struct _xprograminfo *toInit, xconf* xnc);

void xprogram_exit ();
bool xprogram_isexiting ();

#endif /* _PROGRAM_H_ */
