/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Art Vodolazsky <burivuh@crew.org.ru>
 *  a lot of modifications by Alphex Kaänoken <akaanoken@gmail.com>
 *
 *  (c) Crew IT Research Labs 2004
 */

#ifndef _SELECT_MANAGER_H_
#define _SELECT_MANAGER_H_

#include "library.h"
#include "../libmisc/xconfig.h"

/* encodings */
#define UTF8 0
#define LOCALE 1

typedef struct _xselectmanager {
  int state;
  xstr *str;
  xselection *sel;
  xevent *xevnt;
  int (*get_string)(xselection *sel, xstr *str);
  int (*send_string)(xstr *str,xswitchlang *swlng, xevent *xevnt,int sw);
  int (*del_nchrbck)(xevent *xevnt,int n);
  int (*sel_allstr_str)(xevent *xevnt);
  int (*sel_allstr_end)(xevent *xevnt);
  int (*sel_nstr_str)(xevent *xevnt,int n);
  int (*sel_nstr_end)(xevent *xevnt,int n);
  int (*usel_allstr_end)(xevent *xevnt);
  int (*usel_nstr_str)(xevent *xevnt,int n);
  int (*usel_nstr_end)(xevent *xevnt,int n);
  int (*uninit)(struct _xselectmanager *p);
} xselectmanager;

xselectmanager* xselectmanager_init(xselectmanager *p);

/* main API */

/*status xSelectManager_getSelectedString (xString * xstring, xSelection * xselection);
status xSelectManager_sendStringToFocus (xString * xstring,xSwitchLang * xswitchlang,
					 xEvent * xevent, status to_switch);
status xSelectManager_deleteNCharsInCursorStrokeToStart (xEvent * xevent, num N);*/

/* used subfunctions */
/* manipulating with input focus stroke (start point - cursor position)
 * functions, working with the whole stroke are rather quicker because of using Home-End key combinations.
 * other have to work by single symbol (one action -> one symbol -> one KeyPressEvent) 
 */

/*status xSelectManager_selectAllCharsInCursorStrokeToStart (xEvent * xevent);
status xSelectManager_selectAllCharsInCursorStrokeToEnd (xEvent * xevent);
status xSelectManager_selectNCharsInCursorStrokeToStart (xEvent * xevent, num N);
status xSelectManager_selectNCharsInCursorStrokeToEnd (xEvent * xevent, num N);
status xSelectManager_unselectWholeCursorStrokeToEnd (xEvent * xevent);
status xSelectManager_unselectNCharsInCursorStrokeToStart (xEvent * xevent, num N);
status xSelectManager_unselectNCharsInCursorStrokeToEnd (xEvent * xevent, num N);*/

#endif /*_SELECT_MANAGER_H_*/
